library OMC;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
//  OLE,
  OMC_declarations in 'OMC_declarations.pas';

{$E BAV}

{$R *.res}

function BAV_FileChecking: Integer; stdcall;
begin
    result:=AVC_OK;
    _('BAV_FileChecking');
end;

function BAV_Initialize: Integer; stdcall;
begin
    result:=AVC_OK;
    _('BAV_Initialize');
end;

function BAV_Uninitialize: Integer; stdcall;
begin
    result:=AVC_OK;
    _('BAV_Uninitialize');
end;

function BAV_ComNeeded: Integer; stdcall;
begin
    result:=AVC_Error;
end;

function BAV_GetName(B: PChar; BSize: Integer): Integer; stdcall;
begin
  Result := GetStr('Outgoing Mail Checker for UMC', B, BSize);
  _('BAV_GetName');
end;

function BAV_GetVersion(B: PChar; BSize: Integer): Integer; stdcall;
begin
    result:=GetStr(GetOMCver, B, BSize);
  _('BAV_GetVersion');
end;

function BAV_CheckFile(AFileName: PChar; Msg: PChar): Integer; stdcall;
begin
    result:=AVC_OK;
  _('BAV_CheckFile ('+afilename+')');
end;

function BAV_CureFile(AFileName: PChar; Msg: PChar): Integer; stdcall;
begin
    result:=AVC_OK;
  _('BAV_CureFile ('+afilename+')');
end;

function BAV_GetStatus: Integer; stdcall;
begin
    result:=AVC_OK;
  _('BAV_GetStatus');
end;

function BAV_MemoryChecking: Integer; stdcall;
begin
    result:=AVC_OK;
  _('BAV_MemoryChecking');
end;

function BAV_CheckMemory(var ABuf; ABufSize: Integer; Msg: PChar): Integer; stdcall;
var n:tstringlist;
    s:string;
    i:integer;
begin
    result:=AVC_OK;
  _('BAV_CheckMemory');
  _('The bat is about to check '+inttostr(abufsize)+' bytes');
  n:=tstringlist.Create;
  s:=pchar(abuf);
  s:=copy(s,1,abufsize);
  n.Text:=s;
  for i:=0 to n.Count-1 do begin
    s:=n.Strings[i];
    _(s);
    if s='' then break;
  end;


  n.Free;
end;

function BAV_CureMemory(var ABuf; var ABufSize: Integer; Msg: PChar): Integer; stdcall;
begin
    result:=AVC_NotSupported;
  _('BAV_CureMemory');
end;


exports  BAV_Initialize, BAV_Uninitialize,BAV_ComNeeded,BAV_GetName, BAV_GetVersion,

BAV_MemoryChecking, BAV_CheckMemory, BAV_CureMemory, BAV_GetStatus,

  BAV_FileChecking,
  BAV_CheckFile,
  BAV_CureFile;


begin
end.
