unit UMC_MBM;

interface
uses windows, sysutils;
//    ,      //
//   //

  type
    TBus           = (ISA, SMBus, VIA686ABus);
    TSMB           = (SMBIntel, SMBAMD, SMBALi);

  type
    TSharedData = Record
      STemperature       : array [1..10]  of Integer;  // C 10 
                                                       // 
      SVoltage           : array [1..7]   of Real;     //  7 
                                                       // 
      SFan               : array [1..4]   of Integer;  //  4 
                                                       // 
      SMHZ               : Integer;                    //  
                                                       // 
      SNrCPU             : Byte;                       //  
    end;

    TSharedInfo = Record
      SSMB_Base          : Word;                        //   
      SSMB_Type          : TBus;                        //  SMBus/Isa 
                                                        //  
                                                        //   
      SSMB_Code          : TSMB;                        //  SMBus, Intel,
                                                        // AMD  ALi
      SSMB_Addr          : Byte;                        //  
                                                        //   SMBus
      SSMB_Name          : array [0..40]  of Char;      //   SMBus
      SISA_Base          : Word;                        //  
                                                        // 
                                                        //   ISA
      SChipType          : Integer;                     //  ,
                                                        //  
                                                        // Chipinfo.ini
      SVoltageSubType    : Byte;                        //  
                                                        // 
    end;

    TSharedHL = Record                                  //  =  / C 
      STempC             : array [1..10]  of LongInt;   //  
                                                        // 
                                                        // 
      STempA             : array [1..10]  of Extended;  //  
                                                        //  
                                                        // 
      STempL             : array [1..10]  of Real;      //  
                                                        // 
      STempH             : array [1..10]  of Real;      //  
                                                        // 
      SVoltC             : array [1..7]   of LongInt;   //  
                                                        //  
      SVoltA             : array [1..7]   of Extended;  //   
                                                        //  
      SVoltL             : array [1..7]   of Real;      //  
                                                        // 
      SVoltH             : array [1..7]   of Real;      //  
                                                        // 
      SFanC              : array [1..4]   of LongInt;   //  
                                                      //  
      SFanA              : array [1..4]   of Extended;  //   
                                                      //  
      SFanL              : array [1..4]   of Real;      //  
                                                        //  
      SFanH              : array [1..4]   of Real;      //  
                                                        //  
      SStart             : array [0..40]  of Char;      //  
                                                        // 
      SCurrent           : array [0..40]  of Char;      //  
    end;
	
	  TSharedName = Record
      STempName       : array [1..10] of array [0..10] of Char;  // 10 
                                                     //  11   
      SVoltName       : array [1..7]  of array [0..10] of Char;  // 7  
                                                     //  11   
      SFanName        : array [1..4]  of array [0..10] of Char;  // 4 
                                                     //  11   
      SCPUName        : array [0..10] of Char                    // 11 
                                                     //  
	end;

  PSharedData = ^TSharedData;
  PSharedInfo = ^TSharedInfo;
  PSharedHL   = ^TSharedHL;
  PSharedName = ^TSharedName;
  
//        

var
  CPUMhz            : Integer;
  CPUNr             : Byte;
  Temperature       : array [1..10]  of Integer;
  Voltage           : array [1..7]   of Real;
  Fan               : array [1..4]   of Integer;

  UsedBus           : TBus;
  IsaBase           : Word;
  SMB_BASE          : Word;
  SMBusType         : TSMB;
  SMB_NAME          : String;
  SMBChipAddress    : Byte;
  ChipType          : Integer;
  VoltageSubType    : Byte;

  TempL             : array[1..10] of Real;
  TempH             : array[1..10] of Real;
  TempA             : array[1..10] of Extended;
  TempC             : array[1..10] of LongInt;
  VoltL             : array[1..7]  of Real;
  VoltH             : array[1..7]  of Real;
  VoltA             : array[1..7]  of Extended;
  VoltC             : array[1..7]  of LongInt;
  FanL              : array[1..4]  of Real;
  FanH              : array[1..4]  of Real;
  FanA              : array[1..4]  of Extended;
  FanC              : array[1..4]  of LongInt;
  StartingTimeLog   : String;
  CurrentTimeLog    : String;  

  TempName          : array[1..10] of String;
  VoltName          : array[1..7]  of String;
  FanName           : array[1..4]  of String;
  CPUName           : String;

function ReadSharedData : Boolean;
function ReadSharedInfo : Boolean;
function ReadSharedHL   : Boolean;
function ReadSharedName : Boolean;
//function ReadMBM: boolean;

implementation
function ReadMBM: boolean;
var
  PSH          : PSharedData;
  X            : Integer;
begin
  Result:=False;

  hSData:=OpenFileMapping(FILE_MAP_READ, False, '$M$B$M$5$S$D$');

  if hSData=0 then Exit;

  PSH:=MapViewOfFile(hSData, FILE_MAP_READ, 0, 0, 0);

  if PSH=Nil then
  begin
    CloseHandle(hSData);
    Exit;
  end;

  with PSH^ do
  begin
    for X:=1 to 10 do Temperature[X]:=STemperature[X];
    for X:=1 to 7 do Voltage[X]:=SVoltage[X];
    for X:=1 to 4 do Fan[X]:=SFan[X];
    CPUMHZ:=SMHZ;
    CPUNr:=SNrCPU;
  end;

  UnMapViewOfFile(PSH);
  CloseHandle(hSData);
  Result:=True;
end;
////////////////////////////////////////
function ReadSharedData : Boolean;
var
  PSH          : PSharedData;
  hSData       : Integer;
  X            : Integer;
begin
  Result:=False;

  hSData:=OpenFileMapping(FILE_MAP_READ, False, '$M$B$M$5$S$D$');

  if hSData=0 then Exit;

  PSH:=MapViewOfFile(hSData, FILE_MAP_READ, 0, 0, 0);

  if PSH=Nil then
  begin
    CloseHandle(hSData);
    Exit;
  end;

  with PSH^ do
  begin
    for X:=1 to 10 do Temperature[X]:=STemperature[X];
    for X:=1 to 7 do Voltage[X]:=SVoltage[X];
    for X:=1 to 4 do Fan[X]:=SFan[X];
    CPUMHZ:=SMHZ;
    CPUNr:=SNrCPU;
  end;

  UnMapViewOfFile(PSH);
  CloseHandle(hSData);
  Result:=True;
end;

function ReadSharedInfo : Boolean;
var
  PSH          : PSharedInfo;
  hSInfo       : Integer;
begin
  Result:=False;

  hSInfo:=OpenFileMapping(FILE_MAP_READ, False, '$M$B$M$5$S$D$');

  if hSInfo=0 then Exit;

  PSH:=MapViewOfFile(hSInfo, FILE_MAP_READ, 0, 0, 0);

  if PSH=Nil then
  begin
    CloseHandle(hSInfo);
    Exit;
  end;

  with PSH^ do
  begin
    SMB_Base:=SSMB_Base;
    UsedBus:=SSMB_Type;
    SmbusType:=SSMB_Code;
    SMBChipAddress:=SSMB_Addr;
    SMB_Name:=StrPas(SSMB_Name);
    ISABase:=SISA_Base;
    ChipType:=SChipType;
    VoltageSubType:=SVoltageSubType;
  end;

  UnMapViewOfFile(PSH);
  CloseHandle(hSInfo);
  Result:=True;
end;

function ReadSharedHL : Boolean;
var
  PSH          : PSharedHL;
  hSHL         : Integer;
  X            : Integer;
begin
  Result:=False;

  hSHL:=OpenFileMapping(FILE_MAP_READ, False, '$M$B$M$5$S$D$');

  if hSHL =0 then Exit;

  PSH:=MapViewOfFile(hSHL, FILE_MAP_READ, 0, 0, 0);

  if PSH=Nil then
  begin
    CloseHandle(hSHL);
    Exit;
  end;

  with PSH^ do
  begin
    for X:=1 to 10 do
    begin
      TempL[X]:=STempL[X];
      TempH[X]:=STempH[X];
      TempA[X]:=STempA[X];
      TempC[X]:=STempC[X];
    end;
    for X:=1 to 7 do
    begin
      VoltL[X]:=SVoltL[X];
      VoltH[X]:=SVoltH[X];
      VoltA[X]:=SVoltA[X];
      VoltC[X]:=SVoltC[X];
    end;
    for X:=1 to 4 do
    begin
      FanL[X]:=SFanL[X];
      FanH[X]:=SFanH[X];
      FanA[X]:=SFanA[X];
      FanC[X]:=SFanC[X];
    end;
    StartingTimeLog:=StrPas(SStart);
    CurrentTimeLog:=StrPas(SCurrent);
  end;

  UnMapViewOfFile(PSH);
  CloseHandle(hSHL);
  Result:=True;
end;

function ReadSharedName : Boolean;
var
  PSH          : PSharedName;
  hSData       : Integer;
  X            : Integer;
begin
  Result:=False;

  hSData:=OpenFileMapping(FILE_MAP_READ, False, '$M$B$M$5$S$D$');

  if hSData=0 then Exit;

  PSH:=MapViewOfFile(hSData, FILE_MAP_READ, 0, 0, 0);

  if PSH=Nil then
  begin
    CloseHandle(hSData);
    Exit;
  end;

  with PSH^ do
  begin
    for X:=1 to 10 do TempName[X]:=StrPas(STempName[X]);
    for X:=1 to 10 do VoltName[X]:=StrPas(SVoltName[X]);
    for X:=1 to 10 do FanName[X]:=StrPas(SFanName[X]);
    CPUName:=StrPas(SCPUName);
  end;

  UnMapViewOfFile(PSH);
  CloseHandle(hSData);
  Result:=True;
end;


end.
