unit UMC_UC;

interface
const ucdatafn='UC.INI';

procedure ucInit;
procedure ucAddData(s:string);
function isuue(s:string):boolean;
procedure ucExtractData(text:string;out pno,ptotal:integer;out data,fname:string);
procedure ucPerformAssemble(deleteUUE:boolean=false);
procedure ucPerformOldFilesDeletion(dayno:integer);

implementation

{$WARNINGS OFF}
uses UMCaux, UMCsetupform, filectrl, UMClogger, classes, sysutils, inifiles, windows, NMUUE,dateutils;
{$WARNINGS ON}
procedure ucPerformOldFilesDeletion(dayno:integer);
var n:tinifile;
    i,j,k:integer;
    m:tstringlist;
    s,ts:string;
    dt:Tdatetime;
begin
    n:=tinifile.Create(ucdir+ucdatafn);
    m:=tstringlist.Create;
    n.ReadSection('PendingFiles',m);
    for i:=0 to m.Count-1 do
        if m.strings[i]='Count' then begin
            m.Delete(i);
            break;
        end;
    for i:=1 to m.Count do begin
        s:=m.Strings[i-1];
        dt:=n.ReadFloat(s,'DateStamp',now);
        if DaysBetween(dt,now)>=dayno then begin
            k:=n.ReadInteger(s,'Count',0);
            for j:=1 to k do begin
                ts:=n.ReadString(s,inttostr(j),'');
                if fileexists(ts) then deletefile(pchar(ts));
            end;
            n.EraseSection(s);
            n.DeleteKey('PendingFiles',s);
            n.WriteInteger('PendingFiles','Count',n.ReadInteger('PendingFiles','Count',0)-1);
        end;
    end;
    n.Free;
    m.Free;
end;
procedure ucPerformAssemble(deleteUUE:boolean=false);
var n:tinifile;
    m,tm:tstringlist;
    i,j:integer;
    p1,p2,p3:integer;
    p:pointer;
    ins,outs:tfilestream;
    ts,s:string;
    f:boolean;
    uu:TNMUUProcessor;
begin
    n:=tinifile.Create(ucdir+ucdatafn);
    m:=tstringlist.Create;
    n.ReadSection('PendingFiles',m);
    for i:=0 to m.Count-1 do
        if m.strings[i]='Count' then begin
            m.Delete(i);
            break;
        end;
    for i:=1 to m.Count do begin
        s:=m.Strings[i-1];
        _('assembling '+s);
        p1:=n.ReadInteger(s,'CurrentCount',0);
        p2:=n.ReadInteger(s,'Count',0);
        p3:=0;
        for j:=1 to p2 do begin
            ts:=n.ReadString(s,inttostr(j),'');
            if (ts='') or (not fileexists(ts)) then n.DeleteKey(s,inttostr(j))
            else inc(p3);
        end;
        n.WriteInteger(s,'CurrentCount',p3);

        if (p1=p2)and(p1>0) then begin

            //if p2<>1 then begin //ignore if parts=1

            ts:=ucdir+s+'.uue';
            if fileexists(ts) then deletefile(pchar(ts));
            outs:=tfilestream.Create(ts,fmCreate);
            for j:=1 to p2 do begin
                ts:=n.ReadString(s,inttostr(j),'');
                TRY
                ins:=tfilestream.Create(ts,fmOpenRead);
                getmem(p,ins.size);
                ins.ReadBuffer(p^,ins.Size);
                outs.WriteBuffer(p^,ins.Size);
                freemem(p);
                ins.Free;
                EXCEPT
                    _('Error opening ['+ts+'] of '+s);
                END;

            end;
            outs.Free;
            tm:=tstringlist.Create;
            tm.LoadFromFile(ucdir+s+'.uue');
            repeat
                f:=false;
                for j:=0 to tm.Count-1 do
                    if tm.Strings[j]='' then begin
                        tm.delete(j);
                        f:=true;
                        break;
                    end;
            until f=false;
            tm.savetofile(ucdir+s+'.uue');
            tm.Free;

            if fileexists(ucdir+s) then deletefile(pchar(ucdir+s));

            ins:=tfilestream.Create(ucdir+s+'.uue',fmOpenRead);
            outs:=tfilestream.Create(ucdir+s,fmCreate);
            uu:=tNMuuprocessor.create(nil);
            uu.InputStream:=ins;
            uu.OutputStream:=outs;
            uu.Method:=uuCode;
            uu.Decode;
            uu.Free;
            ins.Free;
            outs.Free;

            if deleteUUE then deletefile(pchar(ucdir+s+'.uue'));

            //end; //ignore if parts=1

            for j:=1 to p2 do begin
                ts:=n.ReadString(s,inttostr(j),'');
                deletefile(pchar(ts));
            end;
            n.EraseSection(s);
            n.DeleteKey('PendingFiles',s);
            n.WriteInteger('PendingFiles','Count',n.ReadInteger('PendingFiles','Count',0)-1);
        end;
    end;
    n.Free;
    m.Free;
end;
procedure ucExtractData(text:string;out pno,ptotal:integer;out data,fname:string);
const fn='ttt';
      fn2='ttt2';  
var i,tmp:integer;
    n,m:tstringlist;
    f:boolean;
    a:textfile;
    ts:string;
    inf,outf:tfilestream;
    uu:tnmuuprocessor;
//    f:boolean;
begin
    n:=tstringlist.create;
    m:=tstringlist.create;
    n.text:=text;
    data:='';
    fname:='';
    pno:=-1;
    ptotal:=-1;
    f:=false;
    for i:=0 to n.count-1 do begin
        if pos('section',ansilowercase(n.strings[i]))=1 then begin
            m.clear;
            extractstrings([' '],[],pchar(n.strings[i]),m);
            val(m.strings[1],pno,tmp);
            val(m.strings[3],ptotal,tmp);
            fname:=m.strings[6];
        end;
        if pos('M',n.strings[i])=1 then data:=data+n.strings[i]+#13#10;
        if (pos('base64',n.Strings[i])<>0)and(pno=1)then f:=true;
    end;
    if f then begin
        _('transcoded '+fname);
        assignfile(a,gettpath+fn);
        rewrite(a);
        write(a,data);
        closefile(a);
        inf:=tfilestream.Create(gettpath+fn,fmOpenRead);
        deletefile(pchar(gettpath+fn2));
        outf:=tfilestream.Create(gettpath+fn2,fmCreate);
        uu:=tnmuuprocessor.Create(nil);
        uu.InputStream:=inf;
        uu.OutputStream:=outf;
        uu.Method:=uumime;
        uu.Decode;
        inf.Free;
        outf.Free;
        inf:=tfilestream.Create(gettpath+fn2,fmOpenRead);
        deletefile(pchar(gettpath+fn));
        outf:=tfilestream.Create(gettpath+fn,fmCreate);
        uu.InputStream:=inf;
        uu.OutputStream:=outf;
        uu.Method:=uucode;
        uu.Encode;
        uu.Free;
        inf.Free;
        outf.Free;
        data:='';
//        while no
        assignfile(a,gettpath+fn);
        reset(a);
        while not eof(a) do begin
            readln(a,ts);
            data:=data+ts+#13#10;
        end;
        data:=trim(data);
        closefile(a);
    end;
    data:=trim(data)+#13#10;
    n.free;
    m.free;
end;
function isuue(s:string):boolean;
var i:integer;
    n:tstringlist;
begin
    n:=tstringlist.create;
    n.text:=s;
    result:=false;
    for i:=0 to n.count-1 do begin
        if pos('section',ansilowercase(n.strings[i]))=1 then begin
            result:=true;
            break;
        end;
    end;
    n.free;
end;
procedure ucAddData(s:string);
var ptotal,pno:integer;
    fname:string;
    data:string;
    n:tinifile;
    tmp:integer;
//    fn:string;
    p:pchar;
    fl:textfile;
begin
    if s='' then exit;
    ucExtractData(s,pno,ptotal,data,fname);
    if (fname='')or(data='')or(pno<=0)or(ptotal<=1) then exit;

    GetMem(p,MAX_PATH);



    _('Adding '+inttostr(length(data))+' bytes ['+inttostr(pno)+'/'+inttostr(ptotal)+'] of '+fname);

    n:=tinifile.Create(ucdir+ucdatafn);
    tmp:=n.ReadInteger('PendingFiles',fname,0);
    if tmp=0 then begin
        tmp:=n.ReadInteger('PendingFiles','Count',0);
        inc(tmp);
        n.WriteInteger('PendingFiles','Count',tmp);
    end;
    n.WriteInteger('PendingFiles',fname,n.readinteger('PendingFiles',fname,0)+1);


    GetTempFileName(pchar(ucdir),pchar(fname),0,p);


    n.Writeinteger(fname,'Count',ptotal);
    n.Writeinteger(fname,'CurrentCount',n.Readinteger(fname,'CurrentCount',0)+1);
    n.WriteFloat(fname,'DateStamp',now);
//    n.WriteInteger(
    n.WriteString(fname,inttostr(pno),strpas(p));

//    _(inttostr(length(data)));
//    fl:=tfilestream.Create(ucdir+strpas(p),fmOpenWrite);
//    freemem(p);
//    getmem(p,length(data));
//    p:=pchar(data);
//    fl.WriteBuffer(p,length(data));
//    fl.Free;

//    n.Free;
    assignfile(fl,strpas(p));
    rewrite(fl);
    write(fl,data);
    flush(fl);
    closefile(fl);
    freemem(p);
end;
procedure ucInit;
begin
    if not directoryexists(ucdir) then forcedirectories(ucdir);
    _('UUE completer is initialized');
end;
end.
