unit UMC_Z;

interface

uses zlib, classes, unistorage;
//const max=500000;
const //___maxwlen=80;
      ext='.Stat';
      fv=$87;
var _____cnt:integer=1;

type TZStorage=class(TObject)

    constructor create;
    destructor free;
{    procedure LoadFromFile(filename:string);
    procedure SaveToFile(filename:string);  }
    procedure LoadFromZFile(filename:string);
    procedure Load(filename:string);
    procedure SaveToZFile(filename:string);
    procedure killitem(index:integer);
    function _getitem(index:integer):TStringHOlder;
    procedure _setitem(index:integer;sh:TStringHolder);
    function dataS(index:integer):string;
    function dataV(index:integer):integer;
    function dataSize(index:integer):integer;
    function dataStamp(index:integer):tdatetime;
    function dataStamp2(index:integer):tdatetime;
    function getSV(value:string):integer;
    function _incS(value:string;size:cardinal=0):integer;
    function ix(value:string;size:cardinal=0):integer;
    Procedure StoreData(data:TStringHolder);
    procedure swapdata(i,j:integer);
    procedure clear;
    function cnt:integer;
    function wcnt:integer;
    procedure AddText(s: string; size: cardinal=0);
    public
    {    pdata:PDataStr;
        cnt:integer; }
        no:integer;    
        mem:TMemoryStream;
        modified:boolean;
//        fname:string;
        Tree:TUniTree;
    private
        kk:integer;
        procedure SaveTree(tree:TUniTree;z:TCompressionStream);

end;


implementation

uses UMCaux, UMClogger, sysutils, windows, UMCfuntions;

{ TZStorage }

procedure TZStorage.clear;
begin
    mem.Clear;
end;

function TZStorage.cnt: integer;
begin
    result:=mem.Size div sizeof(TStringHolder);
end;

constructor TZStorage.create;
//var i:integer;
begin
    inherited create;
    modified:=false;
    no:=_____cnt;
    inc(_____cnt);
    //cnt:=0;

{    getmem(pdata,sizeof(TStringHolder)*max);
    for i:=0 to max-1 do pdata^[i]:=nil;}

    mem:=TMemoryStream.Create;
    tree:=TUniTree.Create;
end;

function TZStorage.dataS(index: integer): string;
var sh:TStringHolder;
begin
    result:='';
    if mem=nil then exit;
    try
        mem.Seek(sizeof(TStringHolder)*index,soFromBeginning);
        mem.ReadBuffer(sh,sizeof(TStringHolder));
        result:=trim(sh.str);
    except
        result:='';
    end;

end;

function TZStorage.dataSize(index: integer): integer;
var sh:TStringHolder;
begin
    result:=0;
    if mem=nil then exit;
//    EnterCriticalSection(cs);//_('enter dsi');
    try
        mem.Seek(sizeof(TStringHolder)*index,soFromBeginning);
        mem.ReadBuffer(sh,sizeof(TStringHolder));
        if sh.flag>=fv then
        result:=sh.size
        else
        result:=0;
    except
        result:=-1;
    end;
//    LeaveCriticalSection(cs);//_('leave dsi');
end;

function TZStorage.dataStamp(index: integer): tdatetime;
var sh:TStringHolder;
begin
    result:=now;
    if mem=nil then exit;
//    EnterCriticalSection(cs);//_('enter ds');
    try
        mem.Seek(sizeof(TStringHolder)*index,soFromBeginning);
        mem.ReadBuffer(sh,sizeof(TStringHolder));
        result:=sh.stamp;
    except
        result:=now;
    end;
//    LeaveCriticalSection(cs);//_('leave ds');
end;

function TZStorage.dataStamp2(index: integer): tdatetime;
var sh:TStringHolder;
begin
    result:=now;
    if mem=nil then exit;
//    EnterCriticalSection(cs);//_('enter ds2');
    try
        mem.Seek(sizeof(TStringHolder)*index,soFromBeginning);
        mem.ReadBuffer(sh,sizeof(TStringHolder));
        result:=sh.stamp2;
    except
        result:=now;
    end;
//    LeaveCriticalSection(cs);//_('leave ds2');
end;



function TZStorage.dataV(index: integer): integer;
var sh:TStringHolder;
begin
    result:=0;
    if mem=nil then exit;
    try
        mem.Seek(sizeof(TStringHolder)*index,soFromBeginning);
        mem.ReadBuffer(sh,sizeof(TStringHolder));
        result:=sh.val;
    except
        result:=-1;
    end;
end;

destructor TZStorage.free;
begin
    mem.Free;
    tree.Free;
end;



function TZStorage.getSV(value: string): integer;
var ts:string;
    f:boolean;
    sh:TStringHolder;
begin
    result:=0;
    ts:=removeillegals(trim(value));
    IF TS='' THEN EXIT;

    mem.Seek(0,soFromBeginning);
    f:=false;
    repeat
        try
        mem.ReadBuffer(sh,sizeof(TStringHolder));
        except
        f:=true;
        end;
        if trim(sh.str)=ts then begin
//            f:=true;
//            fnd:=true;
            result:=sh.val;
//            LeaveCriticalSection(cs);//_('leave getsv');
            exit;
        end;
    until f;
//    LeaveCriticalSection(cs);//_('leave getsv');
end;

function TZStorage._incS(value:string;size:cardinal=0):integer;
var ts:string[___maxwlen];
    sh:TStringHolder;
    i,k:integer;
begin
    result:=0;
        if self=nil then exit;
    modified:=true;
    ts:=value;
    k:=0;
    try
    for i:=0 to cnt do
        if datas(i)=value then begin
            mem.Seek(i*sizeof(TStringHolder),soFromBeginning);
            mem.Read(sh,sizeof(TStringHolder));
            inc(sh.val);
            sh.size:=sh.size+size;
            sh.stamp2:=now;
            mem.Seek(i*sizeof(TStringHolder),soFromBeginning);
            mem.Write(sh,sizeof(TStringHolder));
            result:=i;
            exit;
        end;
    except
        _('Can''t increment item');
    end;

    try
        mem.Seek(0,soFromEnd);
        sh.str:=ts;
        sh.val:=1;
        sh.flag:=fv;
        sh.size:=size;
        sh.stamp:=now;
        sh.stamp2:=now;
        mem.WriteBuffer(sh,sizeof(TStringHolder));
    result:=k;
    except
        _('Can''t add item');
    end;
//    LeaveCriticalSection(cs);//_('leave incs');


end;

procedure TZStorage.Load(filename: string);
begin
    modified:=false;
    //if fileexists(filename+ext) then begin
        LoadFromZFile(filename+ext)
  {  end else begin
        LoadFromFile(filename);
    end;
    if fileexists(filename) then deletefile(pchar(filename));}
end;

procedure TZStorage.LoadFromZFile(filename: string);
var n:TFileStream;
    z:TDeCompressionStream;
    i,ct{,k,l}:integer;
    sh,osh:TStringHolder;
//    h:TStringHolder;
begin
    modified:=false;
//    _('Z-Reading from '+filename);
    mem.Clear;
    if not fileexists(filename) then begin
        _('File '+filename+' does not exists');
        exit;
    end;
    n:=TFileStream.Create(filename,fmOpenRead);

    z:=TDeCompressionStream.create(n);

    i:=0;

    ct:=sizeof(TStringHolder);

    osh.str:='';
    osh.val:=0;

    while ct=sizeof(TStringHolder) do begin
        ct:=z.Read(sh,sizeof(TStringHolder));
        try
        if (ct=sizeof(TStringHolder))and(trim(sh.str)<>trim(osh.str))and(trim(sh.str)<>'')and((sh.flag=fv))
        and((sh.stamp2>36000)and(sh.stamp2<182500))
         then begin
            mem.Write(sh,sizeof(TStringHolder));
            osh:=sh;
            inc(i);
        end;
        except
        _('Wrong entry detected');
        end;
    end;

    z.Free;
    n.Free;
    _('Z-Read '+inttostr(i)+' entries from '+filename);
end;

procedure TZStorage.SaveToZFile(filename: string);
var n:TFileStream;
    z:TCompressionStream;
    i:integer;
    f:boolean;
    sh:TStringHolder;
    ll: TCompressionLevel;
//    k:integer;
begin
    case CompressionLevel of
        0:ll:=clNone;
        1:ll:=clFastest;
        2:ll:=clDefault;
        3:ll:=clMax;
        else ll:=clNone;
    end;
    if self=nil then begin
        _('nil!!!!!!!!!!');
        exit;
    end;
//    _('Z-Storing to '+filename);
    n:=TFileStream.Create(filename,fmCreate);

    z:=TCompressionStream.Create(ll,n);
    sh.str:='';
    sh.stamp:=now;
    sh.stamp2:=now;
    sh.size:=cnt;
    sh.flag:=fv;
    z.Write(sh,sizeof(TStringHolder));

//    k:=0;
    f:=false;
    try
    mem.Seek(0,soFromBeginning);
    except
    _('Cant''t seek!');
    end;

    i:=0;

    if cnt<>0 then
    try
    repeat

        try
            mem.ReadBuffer(sh,sizeof(TStringHolder));
            inc(i);
        except
            f:=true;
        end;
        
        if (trim(sh.str)<>'') then begin
            z.Write(sh,sizeof(TStringHolder));
//            _(sh.str+' '+datetimetostr(sh.stamp)+' **** '+datetimetostr(sh.stamp2));
        end;
    until (f)or(i>=cnt);
    except
    end;

{    if no=1 then
        _(1);}
    kk:=0;
    if i<>0 then
    _('Z-Stored '+inttostr(i)+' plain entries to '+filename);
    SaveTree(tree,z);
    _('Z-Stored '+inttostr(kk)+' tree entries to '+filename);
    z.Free;
    n.Free;
    modified:=false;
end;


procedure TZStorage.SaveTree(tree: TUniTree; z: TCompressionStream);
var i:integer;
begin
    if tree.isdata then begin
        z.Write(tree.data,sizeof(TStringHolder));
        inc(kk);
    end;
    for i:=32 to 255 do if tree.l[i]<>nil then savetree(tree.l[i]^,z);
end;

procedure TZStorage.swapdata(i, j: integer);
var {ts:string;
    tv:integer;    }
    sh1,sh2:TStringHolder;
begin
//    EnterCriticalSection(cs);_('enter swap');
    try
    mem.Seek(i*sizeof(TStringHolder),soFromBeginning);
    try
        mem.ReadBuffer(sh1,sizeof(TStringHolder));
    except
        _('Warning: can''t retrieve index #'+inttostr(i));
    end;

    mem.Seek(j*sizeof(TStringHolder),soFromBeginning);
    try
        mem.ReadBuffer(sh2,sizeof(TStringHolder));
    except
        _('Warning: can''t retrieve index #'+inttostr(j));
    end;

    mem.Seek(i*sizeof(TStringHolder),soFromBeginning);
    mem.WriteBuffer(sh2,sizeof(TStringHolder));
    mem.Seek(j*sizeof(TStringHolder),soFromBeginning);
    mem.WriteBuffer(sh1,sizeof(TStringHolder));

    modified:=true;
    except
    _('Exception on swap!');
    end;
//    LeaveCriticalSection(cs);_('leave swap');
end;

function TZStorage.wcnt: integer;
var k:integer;
    sh:TStringHolder;
begin
//    EnterCriticalSection(cs);_('enter wcnt');
    mem.Seek(0,soFromBeginning);
    k:=0;
    try
    while true do begin
        mem.ReadBuffer(sh,sizeof(TStringHolder));
        k:=k+sh.val;
    end;
    except
    end;
    result:=k;
//    LeaveCriticalSection(cs);_('leave wcnt');
end;

function TZStorage._getitem(index: integer): TStringHOlder;
var sh:TStringHolder;
begin
    sh.str:='';
    sh.size:=0;
    sh.val:=0;
    result:=sh;
    if mem=nil then exit;
    try
        mem.Seek(sizeof(TStringHolder)*index,soFromBeginning);
        mem.ReadBuffer(sh,sizeof(TStringHolder));
    except
    end;
    result:=sh;

end;

procedure TZStorage._setitem(index:integer;sh:TStringHolder);
begin
    if mem=nil then exit;
    try
        mem.Seek(sizeof(TStringHolder)*index,soFromBeginning);
        mem.WriteBuffer(sh,sizeof(TStringHolder));
    except
    end;
end;


procedure TZStorage.killitem(index: integer);
var sh:TStringHolder;
begin
    if mem=nil then exit;
    sh.str:='';
    sh.size:=0;
    sh.val:=0;
    try
        mem.Seek(sizeof(TStringHolder)*index,soFromBeginning);
        mem.WriteBuffer(sh,sizeof(TStringHolder));
    except
    end;
end;



function TZStorage.ix(value: string; size: cardinal): integer;
begin
    result:=0;
    tree.AddWord(value,size);
    modified:=true;
end;

procedure TZStorage.AddText(s: string; size: cardinal);
begin
    modified:=true;
    Tree.AddText(s,size);
end;

Procedure TZStorage.StoreData(data:TStringHolder);
begin
    mem.Seek(0,soFromEnd);
    mem.Write(data,sizeof(TStringHolder));
end;

end.
