unit UMCfuntions;

interface
uses classes,UMCaux;
type
  ITBPDataProvider = interface ['{9DD91B89-A551-4180-8A81-2CCF584CD4BF}']
    function GetDataByID(ID: Integer; B: Pointer; BSize: Integer): Integer; stdcall;
    function SetDataByID(ID: Integer; B: Pointer; BSize: Integer): Integer; stdcall;
    function GetIntValue(ID: Integer): Integer; stdcall;
    function SetIntValueF(ID, Value: Integer): Integer; stdcall;
    function GetIDType(ID: Integer): Integer; stdcall;
    function ItemCount: Integer; stdcall;
    function ExecuteMacro(AMacro: Pointer; MaxLen: Integer; InData, OutData: ITBPDataProvider): HResult; stdcall;
  end;
type
  TBPGetDataProc = function(ID, DataID: Integer; Buf: PChar; BufSize: Integer): Integer; stdcall;

const
    AVC_OK  = 0;
    AVC_Error = -3;
    AVC_NotSupported = -1;

const
  midxSubject        = 1;
  midxDate           = 2;
  midxComment        = 3;
  midxInReplyTo      = 4;
  midxMessageID      = 5;
  midxNewsgroups     = 6;
  midxMailer         = 7;
  midxContentType    = 8;
  midxContentSubType = 9;
  midxExpireDate     = 10;
  midxOrganization   = 11;
  midxContentID      = 12;
  midxContentMD5     = 13;
  midxPriority       = 14;
  midxImportance     = 15;
  midxContentLocation= 16;
  midxEncoding       = 17;
  midxCharset        = 18;
  midxBoundary       = 19;
  midxMsgEncoding    = 20;
  midxC_Name         = 21;
  midxCD_Name        = 22;
  midxReportType     = 23;
  midxReferences     = 24;
  midxC_Description  = 25;
  midxContentDisposition = 26;
  midxContentLanguage = 27;
  midxC_ID            = 29;
  midxC_AccessType    = 30;
  midxC_Expiration    = 31;
  midxC_Size          = 32;
  midxC_Permission    = 33;
  midxC_Site          = 34;
  midxC_Directory     = 35;
  midxC_Mode          = 36;
  midxC_Server        = 37;
  midxC_Subject       = 38;
  midx_Files          = 39;
  midx_Msgs           = 40;
  midxReturnPath      = 41;
  midxFromName        = 42;
  midxFromAddr        = 43;
  midxReplyName       = 44;
  midxReplyAddr       = 45;
  midxToName          = 46;
  midxToAddr          = 47;
  midxServerID        = 48;
  midxRRC             = 49;
  midxRRQ             = 50;
  midxFileSubst       = 51;
  midxC_Number        = 52;
  midxC_Total         = 53;
  midxXCFile          = 54;
  midxMDN_To          = 55;
  midxMDN_Options     = 56;
  midxRefList         = 57;
  midxC_MICAlg        = 58;
  midxC_SMIMEType     = 59;
  midxC_Protocol      = 60;
  midxC_ProtocolType  = 61;
  midxC_ProtocolSubType=62;
  midxMatter          = 63;
  midxListHelp        = 64;
  midxListUnsub       = 65;
  midxListSub         = 66;
  midxListPost        = 67;
  midxListOwner       = 68;
  midxListArchive     = 69;
  midxDecodedFrom     = 70;
  midxDecodedTo       = 71;
  midxDecodedSubj     = 72;
  midxDecodedToEtc    = 73;
  midxSender          =79;
  mpidMessageHeader            =  100000;   // raw message RFC 822 header
  mpidMessageBody              =  100001;   // decoded message body (not available yet)
  mpidMessageAttachments       =  100002;   // a CR-delimited list of attachments
  mpidMessageSender            =  100003;   // decoded message sender (FROM)
  mpidMessageSubject           =  100004;   // decoded message subject
  mpidRawMessage               =  100005;   // raw message body

// Here is the current list of template object indexes
// Their meaning should be clear from the name :-)

const
  tpxQuotePrefix       = 200;
  tpxWrapJustify       = 201;
  tpxClear             = 202;
  tpxIsSignature       = 203;
  tpxSignComplete      = 204;
  tpxEncryptComplete   = 205;
  tpxUseSMIME          = 206;
  tpxUsePGP            = 207;
  tpxRCR               = 208;
  tpxRRQ               = 209;
  tpxSplit             = 210;
  tpxCharset           = 211;
  tpxPriority          = 212;
  tpxAttachVCard       = 213;
  tpxAccount           = 214;
  tpxFrom              = 215;
  tpxReplyTo           = 216;
  tpxReturnPath        = 217;
  tpxTo                = 218;
  tpxCC                = 219;
  tpxBCC               = 220;
  tpxOrg               = 221;
  tpxSubject           = 222;
  tpxFullSubject       = 223;
  tpxComment           = 224;
  tpxOldTo             = 225;
  tpxOldFrom           = 226;
  tpxOldReplyTo        = 227;
  tpxOldCC             = 228;
  tpxOldBCC            = 229;
  tpxOldSubject        = 230;
  tpxOldComment        = 231;
  tpxMatter            = 232;
  tpxOldMatter         = 233;
  tpxMsgID             = 234;
  tpxOldMsgID          = 235;
  tpxOldDate           = 236;
  tpxOldRcvDate        = 237;
  tpxOldReturn         = 238;
  tpxOldOrg            = 239;
  tpxOldText           = 240;
  tpxText              = 241;
  tpxSingleRe          = 242;
  tpxHeaders           = 243;
  tpxAttachments       = 244;
  tpxOldAttachments    = 245;
  tpxCookieCount       = 246;
  tpxOldCharset        = 247;
  tpxTotalPages        = 248;
  tpxCurrentPage       = 249;
  tpxTracking          = 248;
  tpxQuoteStyle        = 249;
  tpxTextLF            = 250;
  tpxRegExpPattern     = 251;
  tpxRegExpText        = 252;

  tpxFullText          = 254;
  tpxLastAddress       = 257;
  tpxCursorHeader      = 261;



//  ,   GetFirstHeader,     
function GetLastHeader(headers,hname:string):string;
//        hname
//  - headers
//  ,     
function GetFirstHeader(headers,hname:string):string;
//  ,    
function ExtractServers(headers,delim:string;noip:boolean=true):string;
//  - ,    GetxxxHeader
// Date  
// false,    
//  ,   Date 
function extracttime(s:string;var Date:tdatetime):boolean;
function Getstrff(filename,str:string):string;
function killempty(Text:string):string; //  
function strtrim(Text:string):string; //       
function mkplain(Text:string):string; //    
function cmpp(a,b:integer):integer;
function AddFix(text,prefix,suffix:string):string; //      
function KillCite(text:string;clevel:integer):string; // 
function SecDelivery(Headers:string):string; //       
function SecDeliveryBox(Headers:string):string; //       
function SecReply(Headers:string):string; //   
function GetMM:string;
function kSpaces(text:string):integer; //-   
function kPunc(text:string):integer; //-  
function kLetter(text:string):integer; //- 
function reverse(s:string):string; // 
function reverse2(s:string):string; // ,   
function RemoveLines(s,repl:string;lines:integer):string; //  
function GetStartUpInfo:string; // 
function GetKBD:string; //
function DoFill(S,cuts:string;F:char;lin,lout:string;width,begstr,endstr,justify:integer):string; //. 
function RandomCase(s:string):string; //. 

function GetMousePos:string; // 
function GetMouseInfo:string; //.  
function GetDefaultPrinter: string; //
function GetBattStat:string; //. 
function GetNow:Tdatetime;
function translit(a:string):string; //
function translit2(a:string):string; //2
function translit3(a:string;mode:boolean=false):string; // .
function GetIP:string; // IP
function GetMemoryLoad:string; // 
function GetTotalPhys:string;
function GetAvailPhys:string;
function GetTotalPageFile:string;
function GetAvailPageFile:string;
function GetTotalVirtual:string;
function GetAvailVirtual:string;
function replacech(c:char;str,a:string):string; //   
function GetLinks(Text:string):string; // 
function MinutesLeft(hours,mins,houre,mine:integer;Kind:TstsKind;useunit:boolean=false):string;
function DaysLeft(Zarplata,Zarplatah,Avans,Avansh:integer):string;
function GetLogDrvStr:string;
function GetCompName:string;
function GetUsName:string;
function GetCPUSpeed:real;
function GetCPUf:string;
function GetFilesList(Directory,mask:string):string;
function GetFilesCount(Directory,mask:string):integer;
function GetFilesSize(Directory,mask:string):int64;
function GetProcList:string;
function GetTaskList:string;
function GetCPU_:string;
function GetCPU_v:string;
function GetCPUTicks:extended;
function Get__ticks:integer;
function Get__time:string;
function repl(a:char):char;
function GetScreenDepth:string;
function GetScrRate:string;
function MinsFrom(d,m,y,h,mins:integer;Kind:TstsKind;addunit:boolean=false):string;
function HoursFrom(d,m,y,h:integer;Kind:TstsKind;addunit:boolean=false):string;
function DaysFrom(d,m,y:integer;Kind:TstsKind;addunit:boolean=false):string;
function _gs(Params: ITBPDataProvider;strno:integer):string;
function _gc(Params: ITBPDataProvider;strno:integer):char;
function GetCharset(headers:string):string;
function RemoveIllegals(s:string):string; //    .
function GetMailer(headers:string):string;
function GetProgressDay(d_begin,d_end,width:integer;ech,fch:char;prefix,suffix:string):string;
function GetTimeZone:string;
function GetTimeZoneBias:string;
function GetUserInfo:string;
function ReplaceRegExp(text,srcstr,pattern:string):string;
function FindRegExp(text,findwhat,separator,subtemplate,separator2:string):string;
function GetFileVersion(const FileName:string;var Major,Minor,Release,Build:Integer): Boolean;
function GetFVer(filename:string):string;
function SecLeft:string;
function SecBtw(AYear, AMonth, ADay, AHour, AMinute, ASecond, AMilliSecond: Word):string;
function SecDl(headers,additional:string;mode1,mode2:integer):integer;
function ExtractAddr(s:string):string;
function Daysl(day,month:integer):integer;
function GetIniValue(fname,section,pname:string):integer;
Procedure SetIniValue(fname,section,pname:string;value:integer);
function GetStrValue(fname,section,pname:string):string;
function GetSpamRating(w:string):real;
function GetSpamRatingForText(text:string):real;
Procedure SetStrValue(fname,section,pname:string;value:string);
Procedure IncIniValue(fname,section,pname:string);
function CustomSeparator(str:string;len:integer):string;
function GetLocalIPS(ID:integer):string;overload;
function GetLocalIPS(delim:string):string;overload;
function GetStatisticsFor(entry:string;mode,mode2:char):string;
function CutNmae(s:string):string;
function ExtractStr(s{,separators}:string):string;
function DecodeStr(s:string):string;

implementation
uses sysutils, dateutils, UMClanguages,  winsock,controls,
  UMCnumerical,
    JclSysInfo , inifiles,
  JclFileUtils, forms,
  mimeinln,
  synachar,
  jclshell, UMCsyntax, windows,lm,regexpr, UMClogger, UMCparanoia;

var dt:tdatetime=0;

function DecodeStr(s:string):string;
var n:tstringlist;
    i:integer;
begin
    n:=tstringlist.create;
    n.text:=s;
    for i:=0 to n.Count-1 do
        try
            _(n.Strings[i]);
            n.Strings[i]:=inlinedecode(n.Strings[i],getcurcp);
            _(n.Strings[i]);
        except
        end;
    result:=n.text;

    n.free;

end;
function ExtractStr(s{,separators}:string):string;
var
    n:tstringlist;
    //u:set of char;
//    i:integer;
begin
    n:=tstringlist.create;
    //for i:=1 to length(separators) do u:=u+[separators[i]];
    ExtractStrings([' ',',',';'],[],pchar(s),n);
    result:=n.Text;

    n.free;
end;
function CutNmae(s:string):string;
var n:integer;
begin
    s:=trim(s);
    n:=pos('<',s);
    if n>1 then s:=copy(s,1,n-1);
    n:=pos(': ',s);
    if n>0 then s:=copy(s,n+2,length(s));
//    n:=
    result:=trim(syndequote(s));

    if (result<>'') and (result[length(result)]='"') then result:=copy(result,1,length(result)-1);

end;
function GetStatisticsFor(entry:string;mode,mode2:char):string;
var m:TParaDaemon;
    i,t,mpl:integer;
begin
//    m:=nil;
    entry:=ansilowercase(trim(entry));
    result:='0';
    mode:=UpCase(mode);
    mode2:=UpCase(mode2);
    if not (mode2 in ['T','N','M','F','L','P']) then mode2:='N';
//    _(mode+': ['+entry+']');
    case mode of
        'M':m:=stats[madmailer];
        'S':m:=stats[madsender];
        'R':m:=stats[madrecipient];
    else
        exit;
    end;
    for i:=0 to m.sorter.storage.cnt-1 do
        if trim(ansilowercase(m.sorter.storage.dataS(i)))=entry then
        with m.sorter.storage do
        begin
            case mode2 of
                'N':result:=inttostr(dataV(i));
                'T':result:=bytestostring(dataSize(i),stbKind,true);
                'M':
                    if dataV(i)<>0 then result:=bytestostring(round(dataSize(i)/dataV(i)),stbKind,true)
                    else result:=o[40];
                'F':result:=formatdatetime(CustomDateFormat,datastamp(i));
                'L':result:=formatdatetime(CustomDateFormat,datastamp2(i));
                'P':begin
                        t:=secondsbetween(dataStamp(i),dataStamp2(i));
//                        mpl:=1;
                        if (t=0)or(dataV(i)<=2) then result:=o[40]
                        else begin
                            case tun of
                                0:mpl:=60*60;
                                1:mpl:=60*60*24;
                                2:mpl:=60*60*24*7;
                                3:mpl:=60*60*24*30;
                                4:mpl:=60*60*24*365;
                                else mpl:=0;
                            end;
                            if t<mpl/4 then result:=o[40] else begin
                                t:=round(dataSize(i)/t*mpl);
                                result:=BytesToString(t,stbKind,true);
                            end;
                        end;
                end;
            end;

        end;
//    _(result);

//    i:=m.sorter.storage.


end;


function GetLocalIPS(delim:string):string;overload;
type
  TaPInAddr = array[0..10] of PInAddr;
  PaPInAddr = ^TaPInAddr;
var
  phe: PHostEnt;
  pptr: PaPInAddr;
  Buffer: Array[0..63] of Char;
  I: Integer;
  GInitData: TWSAData;
  list:TStringList;
begin
  list:=tstringlist.Create;
  List.Clear;
  WSAStartup($101, GInitData);
  GetHostName(Buffer, SizeOf(Buffer));
  phe := GetHostByName(buffer);
  if Assigned(phe) then begin
    pPtr := PaPInAddr(phe^.h_addr_list);
    I := 0;
    while Assigned(pPtr^[I]) do  begin
      List.Add(inet_ntoa(pptr^[I]^));
      Inc(I);
    end;
  end;
  for i:=0 to list.Count-1 do
    if i=0 then result:=list.Strings[i]
    else result:=result+delim+list.Strings[i];
  WSACleanup;
  list.Free;
end;

function GetLocalIPS(ID:integer):string;
type
  TaPInAddr = array[0..10] of PInAddr;
  PaPInAddr = ^TaPInAddr;
var
  phe: PHostEnt;
  pptr: PaPInAddr;
  Buffer: Array[0..63] of Char;
  I: Integer;
  GInitData: TWSAData;
  list:TStringList;
begin
    list:=tstringlist.Create;
  List.Clear;
  WSAStartup($101, GInitData);
  GetHostName(Buffer, SizeOf(Buffer));
  phe := GetHostByName(buffer);
  if Assigned(phe) then begin
    pPtr := PaPInAddr(phe^.h_addr_list);
    I := 0;
    while Assigned(pPtr^[I]) do  begin
      List.Add(inet_ntoa(pptr^[I]^));
      Inc(I);
    end;
  end;
  WSACleanup;
  if (ID>=list.Count)or(ID<0) then result:=o[40]
  else result:=list.Strings[ID];
  list.Free;

end;

function CustomSeparator(str:string;len:integer):string;
var i:integer;
begin
    result:='';
    for i:=1 to len do result:=result+str[random(length(str))+1];
end;
function GetSpamRatingForText(text:string):real;
var i,b{,k}:integer;
    r:real;
    s,ts:string;
    sc,nsc:integer;
begin
    result:=0;
    if not sCountSpam then exit;
    sc:=stats[madspam].GetWordCount;
    nsc:=stats[madnonspam].GetWordCount;
    if sc=0 then sc:=1;
    if nsc=0 then nsc:=1;

    r:=0;
    s:=' '+translit3(ansilowercase(text))+' ';
    b:=1;
    i:=0;
//    k:=0;
    repeat
        inc(i);
        if (byte(s[i])<=32)or(s[i] in ['.',',',':','-','!','?',';','''','(',')','/','\','=','>','<']) then begin
            if (i-b>=2) and (i-b<maxwl) then begin
                ts:=copy(s,b+1,i-b-1);
                r:=r+stats[madnonspam].GetWordFreq(ts)/nsc-stats[madspam].GetWordFreq(ts)/sc;
//                GetSpamRating(ts);
//                sorter.storage.incS(copy(s,b+1,i-b-1));
//                _('{'+copy(s,b+1,i-b-1)+'}');
//                inc(k);
            end;
            b:=i;
        end
    until i>=length(s)-1;
   // if k<>0 then     r:=r/k;
    result:=r;
//    _('The mad #'+inttostr(no)+' fast ate '+inttostr(k)+' entries');


end;
function GetSpamRating(w:string):real;
begin
    result:=0;
    if not sCountSpam then exit;
    if stats[madnonspam].sorter.storage.cnt<>0 then
    result:=stats[madnonspam].GetWordFreq(w)/stats[madnonspam].GetWordCount;
    if stats[madspam].sorter.storage.cnt<>0 then
    result:=result-stats[madspam].GetWordFreq(w)/stats[madspam].GetWordCount;
end;
Procedure IncIniValue(fname,section,pname:string);
var n:tinifile;
begin
    //if secondsbetween(now,dt)<1 then exit else dt:=now;
    n:=tinifile.Create(fname);
    n.WriteInteger(section,pname,n.ReadInteger(section,pname,0)+1);
    n.Free;
end;
Procedure SetIniValue(fname,section,pname:string;value:integer);
var n:tinifile;
begin
    n:=tinifile.Create(fname);
    n.WriteInteger(section,pname,value);
    n.Free;
end;

function GetIniValue(fname,section,pname:string):integer;
var n:tinifile;
begin
    n:=tinifile.Create(fname);
    result:=n.ReadInteger(section,pname,0);
    n.Free;
end;

Procedure SetStrValue;
var n:tinifile;
begin
    n:=tinifile.Create(fname);
    n.WriteString(section,pname,value);
    n.Free;
end;

function GetStrValue;
var n:tinifile;
begin
    n:=tinifile.Create(fname);
    result:=n.ReadString(section,pname,'');
    n.Free;
end;

function Daysl(day,month:integer):integer;
var y,m,d,hh,mm,ss,i:word;
    n:tdatetime;
begin
    decodedatetime(now,y,m,d,hh,mm,ss,i);
//    y:=CurrentYear;
    n:=encodedatetime(y,month,day,hh,mm,ss,i);
    if n<now then n:=encodedate(y+1,month,day);
    result:=daysbetween(now,n);
end;
function ExtractAddr(s:string):string;
var i:integer;
begin
    s:=ansilowercase(s);
    i:=pos('<',s);
    if i<>0 then s:=copy(s,i+1,length(s)-i);
    i:=pos('>',s);
    if i<>0 then s:=copy(s,1,i-1);
    i:=pos('(',s);
    if i<>0 then s:=copy(s,1,i-1);
    i:=pos(',',s);
    if i<>0 then s:=copy(s,1,i-1);
    i:=pos(';',s);
    if i<>0 then s:=copy(s,1,i-1);
    s:=trim(s);
    result:=s;
end;
function RemoveIllegals(s:string):string;
var i:integer;
begin
    result:='';
    for i:=1 to length(s) do
        if byte(s[i])>=32 then result:=result+s[i];
end;

function SecBtw(AYear, AMonth, ADay, AHour, AMinute, ASecond, AMilliSecond: Word):string;
var n:tdatetime;
begin
    if tryencodedatetime(AYear, AMonth, ADay, AHour, AMinute, ASecond, AMilliSecond,n) then
        result:=inttostr(abs(secondsbetween(n,now))) else result:=o[40];

end;
function GetFVer(filename:string):string;
var Major,Minor,Release,Build:Integer;
begin
    if GetFileVersion(filename,Major,Minor,Release,Build) then
        result:=format('%d.%d.%d.%d',[Major,Minor,Release,Build])
    else
        result:=o[40];
end;
function GetFileVersion(const FileName:string;var Major,Minor,Release,Build:Integer): Boolean;
var
  InfoSize, Wnd: DWORD;
  VerBuf: Pointer;
  FI: PVSFixedFileInfo;
VerSize: DWORD;
begin
  Result:= False;
  InfoSize:= GetFileVersionInfoSize(PChar(FileName), Wnd);
  if InfoSize <> 0 then begin
    GetMem(VerBuf, InfoSize);
    try
      if GetFileVersionInfo(PChar(FileName), Wnd, InfoSize, VerBuf) then
        if VerQueryValue(VerBuf, '\', Pointer(FI), VerSize) then begin
          Major:= FI.dwFileVersionMS shr 16;
          Minor:= FI.dwFileVersionMS and $FFFF;
          Release:= FI.dwFileVersionLS shr 16;
          Build:= FI.dwFileVersionLS and $FFFF;
          Result:= True;
        end;
    finally
      FreeMem(VerBuf);
    end;
  end;
end;

function char2int(c:char):integer;
begin
    result:=0;
    if c in ['0'..'9'] then result:=byte(c)-byte('0');
    c:=upcase(c);
    if c in ['A'..'Z'] then result:=byte(c)-byte('A')+10;
end;
function FindRegExp(text,findwhat,separator,subtemplate,separator2:string):string;
var n:tregexpr;
    i,k:integer;
    s:string;
begin
    n:=tregexpr.Create;
    n.ModifierM:=true;
    if subtemplate='' then subtemplate:='0';
//    _('['+separator+']['+separator2+']');
    n.Expression:=findwhat;
    result:='';

    if n.Exec(text) then
    repeat
            if result<>'' then result:=result+separator;
            begin
                for i:=1 to length(subtemplate) do begin
                    k:=char2int(subtemplate[i]);
                    s:=n.Match[k];
                    if i=1 then result:=result+s else result:=result+separator2+s;
                end;

            end;
    until not n.ExecNext;
    n.Free;
end;

function ReplaceRegExp(text,srcstr,pattern:string):string;
var n:tregexpr;
begin
    n:=tregexpr.Create;
    n.ModifierM:=true;
    n.Expression:=srcstr;
//    result:=ReplaceRegExpr(srcstr,text,pattern,true);
    result:=n.Replace(text,pattern,true);
    n.Free;
end;
function GetUserInfo:string;
var tt:USER_INFO_3;
    pp:pointer;
begin
    result:=o[40];
    {$WARNINGS OFF}
    pp:=@tt;
    NetUserGetInfo(nil,pwidechar(GetUsName),3,pp);
    {$WARNINGS ON}
    case tt.usri3_priv of
        USER_PRIV_GUEST:result:='Guest';
        USER_PRIV_USER:result:='User';
        USER_PRIV_ADMIN:result:='Administrator';
    end;

//    result:=string(tt.usri3_home_dir);
//    usri3_logon_hours
//    result:=tt.usri3_password;
end;
function GetTimeZoneBias:string;
var nt:TIME_ZONE_INFORMATION;
    h,m:integer;
begin
    getTimeZoneInformation(nt);
    result:='';
    m:=abs(nt.Bias) mod 60;
    h:=-nt.Bias div 60;
    result:=format('%.2d%.2d',[h,m]);
    if h>0 then result:='+'+result;
end;
function GetTimeZone:string;
var nt:TIME_ZONE_INFORMATION;
    p:widechar;
    i:integer;
begin
    getTimeZoneInformation(nt);
    result:='';
//    nt.
    for i:=0 to 31 do begin
    p:=nt.StandardName[i];
    if word(p)=0 then break;
    result:=result+p;
    end;
end;
function GetProgressDay(d_begin,d_end,width:integer;ech,fch:char;prefix,suffix:string):string;
var prg,hour,i:integer;
begin
    result:=o[37];
    if (d_begin>=d_end)or(width<1) then exit;
    hour:=HourOf(now);
    if hour<=d_begin then prg:=0 else
    if hour>=d_end then prg:=width else
    prg:=round((hour+MinuteOf(now)/60-d_begin)/(d_end-d_begin)*width);
    result:='';
    for i:=1 to prg do result:=result+fch;
    for i:=prg+1 to width do result:=result+ech;
    result:=prefix+result+suffix;
end;
function GetMailer(headers:string):string;
var s:string;
    //t:integer;
begin
    s:=GetFirstHeader(headers,'X-Mailer:');
    if s<>'' then
        s:=trim(copy(s,10,length(s)))
    else begin
            s:=GetFirstHeader(headers,'X-FTN-PID:');
            if s<>'' then begin
                s:=trim(copy(s,11,length(s)-10));
            end else begin
                s:=GetFirstHeader(headers,'X-Newsreader:');
                if s<>'' then
                s:=trim(copy(s,14,length(s)));
            end;
    end;
    if s='' then s:='unknown';
    result:=s;
end;
function GetCharset(headers:string):string;
var s:string;
    b:integer;
begin
    s:=AnsiLowerCase(headers);
    s:=GetFirstHeader(s,'content-type');
    b:=pos('charset=',s);
    if b=0 then s:='';
    b:=b+8;
    s:=copy(s,b,length(s)-b+1);
    s:=synDeQuote(s);
    if s='' then s:='unknown';
    b:=pos(';',s);
    if b>0 then s:=copy(s,1,b-1);
    b:=pos(' ',s);
    if b>0 then s:=copy(s,1,b-1);
    if s[length(s)]='"' then s:=copy(s,1,length(s)-1);
    result:=s;

end;
function _gc(Params: ITBPDataProvider;strno:integer):char;
var h:char;
begin
    h:=' ';
    params.GetDataByID(strno,@h,1);
    result:=h;
end;
function _gs(Params: ITBPDataProvider;strno:integer):string;
var p:pchar;
    size:integer;
    s:string;
begin
    size:=params.GetDataByID(strno,nil,-1);
    getmem(p,size);
    params.GetDataByID(strno,p,size);
    s:=copy(p,1,size);
    freemem(p);
    result:=s;
end;

function DaysFrom(d,m,y:integer;Kind:TstsKind;addunit:boolean=false):string;
var
    days:integer;
begin

    try
    days:=DaysBetween(now,encodedatetime(y,m,d,0,0,0,0))+1;
    result:=SecondsToString(days*86400,kind,addunit);
//    dds(days);
    except
    result:=format('%s %.2d.%.2d.%.4d',[o[28],d,m,y]);
    end;
end;
function HoursFrom(d,m,y,h:integer;Kind:TstsKind;addunit:boolean=false):string;
var
    hrs:int64;
begin

    try
    hrs:=HoursBetween(now,encodedatetime(y,m,d,h,0,0,0));
    result:=secondstostring(hrs*3600,kind,addunit);
//    result:=hds(hrs);
    except
    result:=format('%s %.2d.%.2d.%.4d %d',[o[28],d,m,y,h]);
    end;
end;
function MinsFrom(d,m,y,h,mins:integer;Kind:TstsKind;addunit:boolean=false):string;
var
    hrs:int64;
begin

    try
    hrs:=MinutesBetween(now,encodedatetime(y,m,d,h,mins,0,0));
    result:=secondstostring(hrs*60,kind,addunit);
    except
    result:=format('%s %.2d.%.2d.%.4d %d:%d',[o[28],d,m,y,h,mins]);
    end;
end;
function GetScrRate:string;
begin
    result:=inttostr(getdevicecaps(GetDC(application.Handle),VREFRESH));
end;

function GetScreenDepth:string;
begin
      result:=inttostr(getdevicecaps(GetDC(application.Handle),COLORRES));
      if result='24' then result:='32';
end;

function Get__time:string;
var st:_SYSTEMTIME;
begin
      getlocaltime(st);
      result := datetimetostr(now)+'.'+inttostr(st.wMilliseconds);

end;
function Get__ticks:integer;
//var ms,sec,min,hour:word;
begin
{      ms:=GetTickCount;
      sec:=(ms div 1000)mod 60;
      min:=(ms div 60000)mod 60;
      hour:=ms div 3600000;
      ms:=ms mod 1000;
      result := format('%d:%.2d:%.2d,%.4d',[hour,min,sec,ms]);}
      result:=GetTickCount div 1000;
end;

function GetCPUTicks:extended;
begin
    result:=GetTickCount/1000*GetCPUSpeed/1000;

end;

function GetCPU_:string;
var n:TCPUinfo;
    s:string;
begin
    GetCPUInfo(n);
    s:=n.CpuName;

    result:=s;
end;
function GetCPU_v:string;
var n:TCPUinfo;
    s:string;
begin
    GetCPUInfo(n);
    s:=n.Manufacturer;

    result:=s;
end;

function GetTaskList:string;
var n:tstrings;
begin
    n:=tstringlist.Create;
    if GetTasksList(n) then result:=n.Text else result:=o[35];
end;
function GetProcList:string;
var n:tstrings;
begin
    n:=tstringlist.Create;
    if RunningProcessesList(n,true) then result:=n.Text else result:=o[36];
end;
function GetFilesSize(Directory,mask:string):int64;
var n:tsearchrec;
    t:int64;
begin
    directory:=PathAddSeparator(syndequote(directory));
    mask:=syndequote(mask);
    if mask='' then mask:='*.*';
    t:=0;
    if FindFirst(directory+mask,faAnyFile,n)=0 then begin
        repeat
            if not directoryexists(n.Name) then
            t:=t+int64(n.Size);
        until FindNext(n)<>0;
    end;
    result:=t;
    sysutils.findclose(n);
end;

function GetFilesCount(Directory,mask:string):integer;
var n:tsearchrec;
    t:integer;
begin
    directory:=PathAddSeparator(syndequote(directory));
    mask:=syndequote(mask);
    if mask='' then mask:='*.*';
    t:=0;
    if FindFirst(directory+mask,faAnyFile,n)=0 then begin
        t:=1;
        repeat
            if not directoryexists(n.Name) then
            inc(t);
        until FindNext(n)<>0;
    end;
    result:=t;
    sysutils.findclose(n);
end;

function GetFilesList(Directory,mask:string):string;
var n:tsearchrec;
    s:string;
begin
    s:='';
    if mask='' then mask:='*.*';
    if FindFirst(PathAddSeparator(directory)+mask,faAnyFile,n)=0 then begin
        repeat
            if not directoryexists(n.Name) then
            s:=s+extractfilename(n.Name)+#13#10;
        until FindNext(n)<>0;
    end;
    result:=trim(s);
    sysutils.findclose(n);
end;
function GetCPUf:string;
var t:TCPUInfo;
    s:string;
begin
    GetCPUInfo(t);
    s:=t.CpuName;

    s:=t.CPUName+format(' (Stepping %d, Model %d, Family %d',[t.Stepping,t.Model,t.Family]);

    if t.MMX then s:=s+', MMX';
    case t.CpuType of
        CPU_TYPE_INTEL:begin
            if (t.Features and APIC_FLAG)<>0 then s:=s+', APIC';
            if (t.Features and PSE36_FLAG)<>0 then s:=s+', 36-bit addr';
        end;

        CPU_TYPE_AMD:begin
            if t.HasExtendedInfo then
            if (t.Features and EAMD_3DNOW_FLAG)<>0 then s:=s+', 3Dnow!';

        end;
        CPU_TYPE_CYRIX:begin
            if (t.Features and ECYRIX_EMMX_FLAG)<>0 then s:=s+', EMMX';

        end;
    end;

//    if t.AMD3DNow then s:=s+', 3dnow!';
//    if t.APIC then
    s:=s+')';
//    end;
    result:=s;

end;
function GetCPUSpeed:real;
const DelayTime=500;
var TimerHi, TimerLo: DWORD;
PriorityClass, Priority: Integer;
begin
 PriorityClass:=GetPriorityClass(GetCurrentProcess);
 Priority:=GetThreadPriority(GetCurrentThread);
 SetPriorityCLass(GetCurrentProcess,REALTIME_PRIORITY_CLASS);
 SetThreadPriority(GetCurrentThread,THREAD_PRIORITY_TIME_CRITICAL);
 Sleep(10);
 asm
    DW 310Fh           ;//This command of ASM RDTSC -   .
    MOV TimerLo, EAX
    MOV TimerHi, EDX
 end;
 Sleep(DelayTime);
 asm
    DW 310Fh
    SUB EAX, TimerLo
    SBB EDX, TimerHi
    MOV TimerLo, EAX
    MOV TimerHi, EDX
 end;
 SetThreadPriority(GetCurrentThread, Priority);
 SetPriorityClass(GetCurrentProcess,PriorityClass);
 Result:=TimerLo/(1000.0*DelayTime);
end;

function GetUsName:string;
var Size         : cardinal;
    PRes         : PChar;
    BRes         : boolean;
begin
   result:=o[34];
  Size := MAX_COMPUTERNAME_LENGTH + 1;
  PRes := StrAlloc(Size);
  BRes := GetUserName(PRes, Size);
  if BRes then result:=StrPas(PRes);
end;
function GetCompName:string;
var Size         : cardinal;
    PRes         : PChar;
    BRes         : boolean;
begin
    result:=o[33];
  //  
  Size := MAX_COMPUTERNAME_LENGTH + 1;
  PRes := StrAlloc(Size);
  BRes := GetComputerName(PRes, Size);

  if BRes then result:=StrPas(PRes);
end;

function GetLogDrvStr:string;
var h:pchar;
    i,k:integer;

begin
    k:=10000;
    getmem(h,k);
    GetLogicalDriveStrings(k,h);
    for i:=0 to k-2 do
        if byte(h[i])=0 then begin
            h[i]:=' ';
            if byte(h[i+1])=0 then break;
        end;

    result:=strpas(h);
    freemem(h);
end;
function DaysLeft(Zarplata,Zarplatah,Avans,Avansh:integer):string;
var st:_SYSTEMTIME;
    zh,ah,curh:integer;
    s:string;
const dapm:array[1..13]of integer=(31,28,31,30,31,30,31,31,30,31,30,31,31);

begin
      s:='';
      getlocaltime(st);
      curh:=st.wDay*24+st.wHour;
      zh:=Zarplata*24+Zarplatah;
      ah:=Avans*24+Avansh;
      if avans=0 then ah:=10000000;
      if zh<curh then zh:=zh+dapm[st.wMonth]*24;
      if ah<curh then ah:=ah+dapm[st.wMonth]*24;
      zh:=zh-curh;
      ah:=ah-curh;
      if zh<ah then begin
        s:=o[29]+' '+sectostr((zh div 24)*86400,1,stsShortNames);

//        dds(zh div 24);
        if zarplatah in [1..23] then s:=s+' '+sectostr((zh mod 24)*3600,1,stsShortNames);
//        hds(zh mod 24);
        if zarplata=st.wDay then s:=o[30];
      end else begin
        s:=o[31]+' '+sectostr((ah div 24)*86400,1,stsShortNames);
        //dds(ah div 24);
        if avansh in [1..23] then s:=s+' '+sectostr((ah mod 24)*3600,1,stsShortNames);
        //hds(ah mod 24);
        if avans=st.wDay then s:=o[32];
      end;
      result:=s;
end;
function MinutesLeft(hours,mins,houre,mine:integer;Kind:TstsKind;useunit:boolean=false):string;
var st:_SYSTEMTIME;
    rsec:integer;
begin
      getlocaltime(st);
      if (st.wDayOfWeek=0)or(st.wDayOfWeek=6)then result:=o[18] else begin
      if (st.wHour*60+st.wMinute)>(houre*60+mine) then begin
        result:=o[19];
        exit;
      end;
      if (st.wHour*60+st.wMinute)<(hours*60+mins) then begin
        result:=o[20];
        exit;
      end;
      rsec:=(houre*60+mine)*60-((st.wHour*60+st.wMinute)*60+st.wSecond);
      if rsec<0 then rsec:=rsec+24*60*60;
      result:=o[21]+' '+SecondsToString(rsec,Kind,useunit);
      end;

end;
function repl(a:char):char;
const vowell='';
      vowelu='ި';
      consl='';
      consu='';
var i:integer;
begin
    repl:=a;
    for i:=1 to length(vowell) do
        if a=vowell[i] then begin
            repl:=vowell[random(length(vowell))+1];
            exit;
        end;

    for i:=1 to length(vowelu) do
        if a=vowelu[i] then begin
            repl:=vowelu[random(length(vowelu))+1];
            exit;
        end;

    for i:=1 to length(consl) do
        if a=consl[i] then begin
            repl:=consl[random(length(consl))+1];
            exit;
        end;

    for i:=1 to length(consu) do
        if a=consu[i] then begin
            repl:=consu[random(length(consu))+1];
            exit;
        end;

end;
function GetLinks(Text:string):string;
var s:string;
    i,i1,i2:integer;
begin
    s:='';
    text:=text+'     ';
    for i:=1 to length(text) do if text[i]<' ' then text[i]:=' ';
    repeat
        i1:=pos('http:',LowerCase(text));
        i2:=pos('ftp:',LowerCase(text));
        i:=cmpp(i1,i2);
//        if i1<i2 then i:=i1 else i:=i2;
        if i=0 then break;
        text:=copy(text,i,length(text)-i+1);

        i1:=0;
        for i:=1 to length(text) do
            if not(lowercase(text)[i] in ['a'..'z','!'..'/','~','_','@',':','0'..'9']) then begin
                i1:=i;
                break;
            end;
        if i1=0 then i1:=length(text);

        if s<>'' then s:=s+#13#10;
        s:=s+copy(text,1,i1-1);
        text:=copy(text,i1,length(text)-i1+1);

    until length(s)=0;
    result:=s;

end;
function replacech(c:char;str,a:string):string;
var i:integer;
    s:string;
begin
    s:='';
    for i:=1 to length(a) do
        if a[i]<>c then s:=s+a[i] else s:=s+str;
    replacech:=s;
end;
function GetAvailVirtual:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2f %s',[lpms.dwAvailVirtual/1048576,o[82]]);
end;
function GetMM:string;
//var lpMS : TMemoryStatus;
begin
    result:=format('[%03.2f]',[allocmemsize/1048576]);
{  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('[%04.2f/%04.2f]',[(lpms.dwTotalPhys-lpms.dwAvailPhys)/1048576,(lpms.dwTotalPageFile-lpms.dwAvailPageFile)/1048576]);}

  //lpms.dwTotalVirtual/1048576,o[82]]);
end;
function GetTotalVirtual:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2f %s',[lpms.dwTotalVirtual/1048576,o[82]]);
end;
function GetAvailPageFile:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2f %s',[lpms.dwAvailPageFile/1048576,o[82]]);
end;
function GetTotalPageFile:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2f %s',[lpms.dwTotalPageFile/1048576,o[82]]);
end;
function GetAvailPhys:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2f %s',[lpms.dwAvailPhys/1048576,o[82]]);
end;
function GetTotalPhys:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2f %s',[lpms.dwTotalPhys/1048576,o[82]]);
end;
function GetMemoryLoad:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=inttostr(lpms.dwMemoryLoad)+'%';
end;

function GetIP:string;
const BufSize=255;
var
  Buf: pointer;
  Host : PHostEnt;
begin
    buf:=nil;
  try
    GetMem(Buf,BufSize);
    Winsock.GetHostName(Buf, BufSize);
    Host:=Winsock.GetHostByName(buf);
    if Host=NIL then result:= o[52]//WinSock.htonl($07000001)  (*127.0.0.1 *)
    else result:= inet_ntoa(TInAddr(pointer(Host^.h_addr_list^)^));
    //   String.
  finally
    FreeMem(Buf,BufSize);
  end;
end;
function translit2(a:string):string;
var i,j:integer;
    s:string;
    f:boolean;
const tranr='';
      trane='jykeeHGww3xbfBapog*e4cmutb6JYKEHGWW3XbFBAPODE4CMUTb6EnnUu';
begin
//    translit:='unfinished!';

    s:='';
    for i:=1 to length(a) do
        case a[i] of
            '':s:=s+'>|<';
            '','':s:=s+'/|';
            '','':s:=s+'b|';
            '','':s:=s+'R';
            '','':s:=s+'|O';

        else
            f:=true;
            for j:=1 to length(tranr) do
                if a[i]=tranr[j] then begin
                    s:=s+trane[j];
                    f:=false;
                    break;
                end;
            if f then s:=s+a[i];
        end;
    translit2:=s;
end;
function translit3(a:string;mode:boolean=false):string; // .
var i,j:integer;
    s:string;
    f:boolean;
const tranr='';
      trane='jykeehgwwzxbfvapogzeccmutbbjukengwwzxbfvarodeccmutb6ennuuzllyyaauu';
      ignore='~`!@#$%^&*()_+-=[]{};'':",./<>?|\'#0#1#2#3#4#5#6#7#8#9#10#11#12#13#14#15#16#17#18#19#20#21#22#23#24#25#26#27#28#29#30#31;
begin
//    translit:='unfinished!';
    if mode then a:=ansilowercase(a);
    //for i:=1 to length(a) do if a[i] in ['a'..'z'] then a[i]:=' ';

    s:=' ';
    for i:=1 to length(a) do begin
            f:=true;
            for j:=1 to length(tranr) do
                if a[i]=tranr[j] then begin
                    s:=s+trane[j];
                    f:=false;
                    break;
                end;
            for j:=1 to length(ignore) do
                if a[i]=ignore[j] then begin
                    f:=false;
                    if s[length(s)]<>' ' then s:=s+' ';

                    break;
                end;
            if f then s:=s+a[i];
    end;
    translit3:=s;
   // _(s);
end;
function translit(a:string):string;
var i,j:integer;
    s:string;
    f:boolean;
const tranr=''+'';
      trane='yukengzfyvaproldesmit''b'''+'YUKENGZFYVAPROLDESMIT''B''';
begin
    translit:='unfinished!';

    s:='';
    for i:=1 to length(a) do
        case a[i] of
            '':s:=s+'sh';
            '':s:=s+'sch';
            '':s:=s+'zh';
            '':s:=s+'ya';
            '':s:=s+'ch';
            '':s:=s+'yu';
            '':s:=s+'yo';
            '':s:=s+'kh';
            '':s:=s+'ts';

            '':s:=s+'Sh';
            '':s:=s+'Sch';
            '':s:=s+'Zh';
            '':s:=s+'Ya';
            '':s:=s+'Ch';
            '':s:=s+'Yu';
            '':s:=s+'Yo';
            '':s:=s+'Kh';
            '':s:=s+'Ts';

        else
            f:=true;
            for j:=1 to length(tranr) do
                if a[i]=tranr[j] then begin
                    if not((trane[j] in ['Y','y']) and (s[length(s)] in ['Y','y'])) then
                    s:=s+trane[j];
                    f:=false;
                    break;
                end;
            if f then s:=s+a[i];
        end;
    translit:=s;
end;
function GetNow:Tdatetime;
begin
    result:=now;
end;
function SecLeft:string;
var h:_system_power_status;
begin
    result:='-1';
    GetSystemPowerStatus(h);
    if (h.ACLineStatus=0) and (h.BatteryLifeTime<>$FFFFFFFF) then result:=inttostr(h.BatteryLifeTime);

end;
function GetBattStat:string;
var h:_system_power_status;
    s:string;
begin

    GetSystemPowerStatus(h);
    case h.ACLineStatus of
        1:s:=o[9];
        255:s:=o[8];
        0:begin
            case h.BatteryFlag of
//                255:s:=o[10];
                128:s:=o[11];
                else s:=o[10];
            end;
            if h.BatteryLifePercent<>255 then s:=s+', '+inttostr(h.BatteryLifePercent)+'% '+o[16]
            else
            case h.BatteryFlag of
                1:s:=s+', '+o[12];
                2:s:=s+', '+o[13];
                4:s:=s+', '+o[14];
            end;
            if h.BatteryLifeTime<>$FFFFFFFF then s:=s+format(', %.1f '+o[45]+' '+o[16],[h.BatteryLifeTime/60]);
        end;


    end;
    if h.BatteryFlag=8 then s:=s+', '+o[15];
    result:=s;
end;

function GetDefaultPrinter: string;
var
  ResStr: array[0..255] of Char;
begin
  GetProfileString('Windows', 'device', '', ResStr, 255);
  Result := StrPas(ResStr);
end;
function GetMousePos:string;
begin
    result:=format('(%d,%d)',[mouse.cursorpos.x,mouse.cursorpos.y]);
end;
function RandomCase(s:string):string;
var i:integer;
    c:string;
begin
    for i:=1 to length(s) do begin
        c:=s[i];
        if random(2)=1 then c:=AnsiUpperCase(c)
        else c:=AnsiLowerCase(c);
        s[i]:=c[1];

        end;
    result:=s;

end;
function GetMouseInfo:string;
var t:integer;
    s:string;
begin
    t:=GetSystemMetrics(SM_CMOUSEBUTTONS);

    if t=0 then s:=o[5] else begin
        s:=inttostr(t)+o[6];
        if mouse.WheelPresent then s:=s+' '+o[7];
    end;
    result:=s;
end;
function DoFill(S,cuts:string;F:char;lin,lout:string;width,begstr,endstr,justify:integer):string;
var n:tstrings;
    i:integer;
    tts,ts:string;
begin
    ts:='';
    for i:=1 to width do ts:=ts+f;
    tts:=ts;
//    if (begstr+endstr<>0) then
    ts:=ts+#13#10;
    n:=tstringlist.Create;
    if cuts<>'' then begin
    i:=pos(cuts,s);
    if i>0 then
    n.Text:=copy(s,1,i-1);
    end
    else n.Text:=s;


    for i:=0 to n.Count-1 do // 
        if (n.strings[i]<>'') then begin
        n.Strings[i]:=lin+n.Strings[i]+lout;
        with n do
        while length(strings[i])<width do
            case justify of
                1:strings[i]:=strings[i]+f;
                2:strings[i]:=f+strings[i];
            else
                if (length(strings[i]) mod 2)=0 then
                    strings[i]:=strings[i]+f
                else
                    strings[i]:=f+strings[i];
            end;

        end
        else n.Strings[i]:=ts;

    for i:=0 to n.Count-1 do //    
        if length(n.Strings[i])>width then
            if (n.strings[i][length(n.Strings[i])-1]=#$d)
            and (n.strings[i][length(n.Strings[i])]=#$a)
            then n.Strings[i]:=copy(n.Strings[i],1,width);

    for i:=1 to begstr do n.text:=ts+n.text;
    if endstr>0 then
        for i:=1 to endstr do
            if i<>endstr then
            n.text:=n.text+ts
            else
            n.text:=n.text+tts;


    result:=n.Text;
            if (result[length(result)-1]=#$d)
            and (result[length(result)]=#$a)
            then result:=copy(result,1,length(result)-2);

    n.Free;
end;
function GetKBD:string;
var h:pchar;
begin
    GetMem(h,15000);
    GetKeyboardLayoutName(h);
    result:=StrPas(h);
    freemem(h);
end;
function GetStartUpInfo:string;
begin

    result:=o[1];
    case GetSystemMetrics(SM_CLEANBOOT) of
        0:result:=o[2];
        1:result:=o[3];
        2:result:=o[4];
    end;

end;
function RemoveLines(s,repl:string;lines:integer):string;
var n:tstrings;
    rs:string;
    i:integer;
begin
    rs:=s;
    n:=tstringlist.Create;
    n.Text:=s;
    if n.Count>lines then begin
    rs:='';
    for i:=0 to lines div 2-1 do
        rs:=rs+n.Strings[i]+#13#10;
    if repl<>'' then rs:=rs+repl+#13#10;
    for i:=n.count-(lines-(lines div 2)) to n.count-1 do
        rs:=rs+n.Strings[i]+#13#10;
    end;
    result:=rs;
    n.free;

end;
function reverse(s:string):string;
var n:tstrings;
    rs:string;
    i,j:integer;
begin
    rs:='';
    n:=tstringlist.Create;
    n.Text:=s;
    for i:=n.Count-1 downto 0 do begin
        for j:=length(n.Strings[i]) downto 1 do
            rs:=rs+n.Strings[i][j];
        rs:=rs+#13#10;
        end;


    result:=rs;
    n.free;
end;
function reverse2(s:string):string;
var n:tstrings;
    rs:string;
    i,j:integer;
begin
    rs:='';
    n:=tstringlist.Create;
    n.Text:=s;
    for i:=0 to n.Count-1 do begin
        for j:=length(n.Strings[i]) downto 1 do
            rs:=rs+n.Strings[i][j];
        rs:=rs+#13#10;
        end;


    result:=rs;
    n.free;
end;
function SecReply(Headers:string):string;
var n:tstringlist;
    d1,d2:tdatetime;
    s,s1:string;
    sd:integer;
    m:_SYSTEMTIME;

begin
    getsystemtime(m);
    n:=tstringlist.Create;
    n.Text:=headers;
    s1:=GetFirstHeader(headers,'Date:');
    extracttime(s1,d1);
    d2:=EncodeDateTime(m.wYear,m.wMonth,m.wDay,m.wHour,m.wMinute,m.wSecond,m.wMilliseconds);

    sd:=abs(secondsbetween(d2,d1));
    s:='';
    s:=inttostr(sd mod 60)+' '+o[44];
    if sd>=60 then s:=inttostr((sd div 60) mod 60)+' '+o[45]+' '+s;
    if sd>=3600 then s:=inttostr((sd div 3600)mod 24)+' '+o[46]+' '+s;
    if sd>=86400 then s:=inttostr((sd div 86400))+' '+o[47]+' '+s;
    result:=s;

    n.Free;
end;
function kLetter(text:string):integer;
var i,k:integer;
begin
    k:=0;
    text:=AnsiUpperCase(text);
    for i:=1 to length(text) do if text[i] in ['A'..'Z',''..''] then inc(k);
    result:=k;
end;function kPunc(text:string):integer;
var i,k:integer;
begin
    k:=0;
    for i:=1 to length(text) do if text[i] in ['`','!','*','(',')','-','.',',','''','?','/','\','"',':',';'] then inc(k);
    result:=k;
end;
function kSpaces(text:string):integer;
var i,k:integer;
begin
    k:=0;
    for i:=1 to length(text) do if text[i]=' ' then inc(k);
    result:=k;
end;

function RCVdatetoTdatetime(s:string):Tdatetime;
var n:tstringlist;
     AYear, AMonth, ADay, AHour, AMinute, ASecond:word;
     t:integer;
begin
//    result:=now;
    n:=tstringlist.Create;
    s:=AnsiLowerCase(s);
    ExtractStrings([' ',',',':'],[','],pchar(s),n);
    val(n.Strings[0],AHour,t);
    val(n.Strings[1],AMinute,t);
    val(n.Strings[2],ASecond,t);
//    if n.Strings[3]='pm' then AHour:=AHour+12;
    val(n.Strings[5],ADay,t);
    val(n.Strings[6],AYear,t);
    AMonth:=0;
    n.Strings[4]:=copy(n.Strings[4],1,3);
    case n.Strings[4][1] of
        'f':AMonth:=2;
        's':AMonth:=9;
        'o':AMonth:=10;
        'n':AMonth:=11;
        'd':AMonth:=12;
    else
        if n.Strings[4]='jan' then AMonth:=1;
        if n.Strings[4]='mar' then AMonth:=3;
        if n.Strings[4]='apr' then AMonth:=4;
        if n.Strings[4]='may' then AMonth:=5;
        if n.Strings[4]='jun' then AMonth:=6;
        if n.Strings[4]='jul' then AMonth:=7;
        if n.Strings[4]='aug' then AMonth:=8;
    end;


    if not tryencodedatetime(AYear, AMonth, ADay, AHour, AMinute, ASecond,0,result)
    then result:=now;

    n.Free;
end;

function SecDl(headers,additional:string;mode1,mode2:integer):integer;
var d1,d2:Tdatetime;
    n:_TIME_ZONE_INFORMATION;
    bias:integer;

begin
    GetTimeZoneInformation(n);
    bias:=n.Bias+n.DaylightBias;
//    _('ADDITIONAL: '+additional);
//    _(inttostr(Bias));

    try
    case mode1 of
        1:extracttime(GetFirstHeader(headers,'Date:'),d1);
        2:extracttime(GetLastHeader(headers,'Received:'),d1);
        3:extracttime(GetFirstHeader(headers,'Received:'),d1);
        4:d1:=IncMinute(RCVdatetoTdatetime(additional),Bias);
        5:d1:=IncMinute(now,Bias);
    end;
//    _('d'+inttostr(mode1)+': '+datetimetostr(d1));
    except
    _('ERROR: d'+inttostr(mode1)+': '+datetimetostr(d1));
    end;

    try
    case mode2 of
        1:extracttime(GetFirstHeader(headers,'Date:'),d2);
        2:extracttime(GetLastHeader(headers,'Received:'),d2);
        3:extracttime(GetFirstHeader(headers,'Received:'),d2);
        4:d2:=IncMinute(RCVdatetoTdatetime(additional),Bias);
        5:d2:=IncMinute(now,Bias);
    end;
//    _('d'+inttostr(mode2)+': '+datetimetostr(d2));
    except
    _('ERROR: d'+inttostr(mode2)+': '+datetimetostr(d2));
    end;

    result:=abs(secondsbetween(d2,d1));
end;

function SecDelivery(Headers:string):string;
var n:tstringlist;
    d1,d2:tdatetime;
    s,s1,s2:string;
    sd:integer;

begin
    n:=tstringlist.Create;
    n.Text:=headers;
    s1:=GetFirstHeader(headers,'Received:');
    s2:=GetLastHeader(headers,'Received:');
//    s2:=GetLastHeader(headers,'Date:');
    extracttime(s1,d1);
    extracttime(s2,d2);

    sd:=abs(secondsbetween(d2,d1));
    s:='';
    s:=inttostr(sd mod 60)+' '+o[44];
    if sd>=60 then s:=inttostr((sd div 60) mod 60)+' '+o[45]+' '+s;
    if sd>=3600 then s:=inttostr((sd div 3600)mod 24)+' '+o[46]+' '+s;
    if sd>=86400 then s:=inttostr((sd div 86400))+' '+o[47]+' '+s;

    result:=s;

    n.Free;
end;
function SecDeliveryBox(Headers:string):string;
var n:tstringlist;
    d1,d2:tdatetime;
    s,s1,s2:string;
    sd:integer;

begin
    n:=tstringlist.Create;
    n.Text:=headers;
    s1:=GetFirstHeader(headers,'Received:');
//    s2:=GetLastHeader(headers,'Received:');
    s2:=GetLastHeader(headers,'Date:');
    extracttime(s1,d1);
    extracttime(s2,d2);

    sd:=abs(secondsbetween(d2,d1));
    s:='';
    s:=inttostr(sd mod 60)+' '+o[44];
    if sd>=60 then s:=inttostr((sd div 60) mod 60)+' '+o[45]+' '+s;
    if sd>=3600 then s:=inttostr((sd div 3600)mod 24)+' '+o[46]+' '+s;
    if sd>=86400 then s:=inttostr((sd div 86400))+' '+o[47]+' '+s;

    result:=s;

    n.Free;
end;
function KillCite(text:string;clevel:integer):string;
var ts,s:string;
    n:tstringlist;
    i:integer;
begin
    result:=text;
    n:=tstringlist.Create;
    n.Text:=text;
    s:='';
    ts:='';
    for i:=1 to clevel do ts:=ts+'>';
    if ts='' then exit;

    for i:=0 to n.Count-1 do
        if pos(ts,n.Strings[i])=0 then s:=s+n.Strings[i]+#13#10;

    result:=s;
    n.Free;

end;
function AddFix(text,prefix,suffix:string):string;
var n:tstringlist;
    i:integer;
begin
    n:=tstringlist.Create;
    n.Text:=text;
    for i:=0 to n.Count-1 do
        n.Strings[i]:=prefix+n.Strings[i]+suffix;
    result:=n.Text;
    n.Free;

end;
function cmpp(a,b:integer):integer;
begin
    if a=0 then result:=b else
    if b=0 then result:=a else
    if a<b then result:=a else result:=b;
end;
function mkplain(Text:string):string;
var n:tstringlist;
    s:string;
    i:integer;
begin
    s:='';
    n:=tstringlist.create;
    n.Text:=text;
    for i:=0 to n.Count-1 do
        if n.Strings[i]<>'' then
        s:=trim(s)+' '+trim(n.Strings[i]);
    result:=s;
    n.Free
end;
function strtrim(Text:string):string;
var n:tstringlist;
    s:string;
    i:integer;
begin
    s:='';
    n:=tstringlist.create;
    n.Text:=text;
    for i:=0 to n.Count-1 do
        n.Strings[i]:=trim(n.Strings[i]);
    result:=n.Text;
    n.Free
end;
function killempty(Text:string):string;
var n:tstringlist;
    s:string;
    i:integer;
begin
    s:='';
    n:=tstringlist.create;
    n.Text:=text;
    for i:=0 to n.Count-1 do
        if trim(n.Strings[i])<>'' then begin
        if s='' then s:=n.Strings[i]
        else s:=s+#13#10+n.Strings[i];
        end;
    result:=s;
    n.Free
end;
function Getstrff(filename,str:string):string;
var n:tstringlist;
    i,k:integer;
begin
    result:='';
    n:=tstringlist.Create;
    n.LoadFromFile(filename);
    for i:=0 to n.Count do
        if pos(str,n.strings[i])=1 then begin
            k:=pos(' ',n.strings[i]);
            result:=copy(n.strings[i],k+1,length(n.strings[i])-k);
            n.Free;
            exit;
        end;
    n.Free;
end;

//  - ,    GetxxxHeader
// Date  
// false,    
//  ,   Date 
function extracttime(s:string;var Date:tdatetime):boolean;
var i:integer;
    n:tstringlist;

    dd,mm,yy:integer;
    h,m,sc,delta:integer;
    z,z2:tdatetime;


begin
    z2:=date;
    n:=tstringlist.Create;
//    _('EXTR: '+s);
    while pos(';',s)<>0 do begin
        i:=pos(';',s);
        s:=copy(s,i+1,length(s)-i+1);
    end;
    while pos(',',s)<>0 do begin
        i:=pos(',',s);
        s:=copy(s,i+1,length(s)-i+1);
    end;
//    _('EXTR: '+s);

    extractstrings([' ',':','/'],[],pchar(s),n);
    dd:=strtoint(n.Strings[0]);
    n.Strings[1]:=lowercase(n.Strings[1]);
    mm:=0;
    case n.Strings[1][1] of
        'f':mm:=2;
        's':mm:=9;
        'o':mm:=10;
        'n':mm:=11;
        'd':mm:=12;
    else
        if n.Strings[1]='jan' then mm:=1;
        if n.Strings[1]='mar' then mm:=3;
        if n.Strings[1]='apr' then mm:=4;
        if n.Strings[1]='may' then mm:=5;
        if n.Strings[1]='jun' then mm:=6;
        if n.Strings[1]='jul' then mm:=7;
        if n.Strings[1]='aug' then mm:=8;
    end;
    yy:=strtoint(n.Strings[2]);
    h:=strtoint(n.Strings[3]);
    m:=strtoint(n.Strings[4]);
    sc:=strtoint(n.Strings[5]);
    if (n.Strings[6]='GMT') or (n.Strings[6]='UMC') then
        delta:=0
    else
        delta:=-strtoint(n.Strings[6]) div 100;
    if yy<2000 then yy:=yy+2000;
    result:=tryencodedatetime(yy,mm,dd,h,m,sc,0,z);
    if result then begin
        z:=inchour(z,delta);
        date:=z;
    end else date:=z2;
//    _(s+' '+datetostr(date));
    n.Free;
end;
//        hname
//  - headers
//  ,     
function GetFirstHeader(headers,hname:string):string;
var s:string;
    n:tstringlist;
    i,j:integer;
    eflag:boolean;
begin
    s:='';
    eflag:=false;
    n:=tstringlist.Create;
    n.Text:=headers;
    for i:=0 to n.Count-1 do begin
        if eflag then break;
        if pos(hname,n.Strings[i])=1 then begin
            s:=trim(n.Strings[i]);
            for j:=i+1 to n.Count-1 do
                if (n.Strings[j]<>'')and ((byte(n.Strings[j][1])<=32)or(n.Strings[j][1] in ['0'..'9'])) then
                s:=trim(s)+' '+trim(n.Strings[j]) else
                break;
            eflag:=true;
        end;
    end;

    result:=trim(s);

    n.free;
end;
//  ,   GetFirstHeader,     
function GetLastHeader(headers,hname:string):string;
var s:string;
    n:tstringlist;
    i,ii,j:integer;
begin
    s:='';
    ii:=0;
    n:=tstringlist.Create;
    n.Text:=headers;
    for i:=0 to n.Count-1 do
        if pos(hname,n.Strings[i])<>0 then ii:=i;

    s:=trim(n.Strings[ii]);
    for j:=ii+1 to n.Count-1 do
       //if n.Strings[j][1]=' '
       if (n.Strings[j]<>'')and ((byte(n.Strings[j][1])<=32)or(n.Strings[j][1] in ['0'..'9'])) 

       then s:=trim(s)+' '+trim(n.Strings[j]) else break;

    result:=trim(s);

    n.free;
end;

function isIP(n:string):boolean;
var i:integer;
begin
    result:=true;
    for i:=1 to length(n) do
        result:=result and (n[i] in ['0'..'9','.']);
end;

function debr(n:string):string;
begin
    result:=n;
    if result='' then exit;
    if (result[1]='(') and (result[length(result)]=')') then begin
        result:=copy(result,2,length(result)-2);
        exit;
    end;
    if (result[1]='[') and (result[length(result)]=']') then begin
        result:=copy(result,2,length(result)-2);
        exit;
    end;
    if (result[1]='?') and (result[length(result)]='?') then begin
        result:=copy(result,2,length(result)-2);
        exit;
    end;

end;

function ConvertToServ(line:string):string;
var n:tstringlist;
    i:integer;
    s1,s2:string;
    needname:boolean;
begin
    s1:='';
    s2:='';
    needname:=false;
    n:=tstringlist.Create;
    extractstrings([' '],[],pchar(line),n);
    for i:=0 to n.Count-1 do begin
        if (n.Strings[i]='from') and (n.Count>=i) then begin
            s1:=debr(n.Strings[i+1]);
            needname:=(s1='unknown') or (isIP(s1));
        end;
        if (n.Strings[i]='by') and (n.Count>=i) then begin
            needname:=false;
            s2:=debr(n.Strings[i+1]);
        end;
        if needname and (n.Strings[i][1]='(') then begin
            if (debr(n.Strings[i])<>n.Strings[i])or(ansilowercase(n.Strings[i])='(helo') then
            s1:=debr(n.Strings[i]);
            if (s1='(HELO') and (n.Count>=i) then begin
                s1:=n.Strings[i+1];
                s1:=copy(s1,1,length(s1)-1);
            end;
            needname:=isIP(s1);
        end;
    end;
    s1:=debr(s1);
    s2:=debr(s2);
    if (s1<>'')and(s2<>'')then result:=s2+#13#10+s1 else result:=s2+s1;
    n.Free;
end;

function ExtractServers(headers,delim:string;noip:boolean=true):string;
var s:string;
    n,m:tstringlist;
    i:integer;
    cf:boolean;
begin
    s:='';
    n:=tstringlist.Create;
    m:=tstringlist.Create;
    n.Text:=headers;
    for i:=0 to n.Count-1 do begin
        if pos('Received:',n.Strings[i])=1 then begin
            m.Add(n.Strings[i]);
        end;
        if (n.Strings[i]<>'') and (n.Strings[i][1]=' ') then begin
            m.strings[m.Count-1]:=m.strings[m.Count-1]+n.Strings[i];
        end;
    end;
    for i:=0 to m.Count-1 do
        m.Strings[i]:=copy(m.Strings[i],11,length(m.Strings[i])-10);

    repeat
    cf:=false;
    for i:=0 to m.Count-1 do begin
        if pos('from',m.Strings[i])<>1 then begin
            m.Delete(i);
            cf:=true;
            break;
        end;
    end;
    until cf=false;

    n.Clear;
    for i:=0 to m.Count-1 do n.Text:=n.Text+ConvertToServ(m.Strings[i])+#13#10;

    repeat
        cf:=false;
        for i:=0 to n.Count-1 do begin
            if ((i<n.Count-1)and(n.Strings[i]=n.Strings[i+1])) or (noip and isip(n.Strings[i])) then begin
                n.Delete(i);
                cf:=true;
                break;
            end;
        end;
    until cf=false;

    result:='';

    for i:=n.Count-1 downto 0 do
        if i<>0 then result:=result+n.Strings[i]+delim
        else
        result:=result+n.Strings[i];

    n.free;
    m.Free;
end;

procedure umcExceptLowHandler(ExceptObject: TObject; ExceptAddr: Pointer);
begin
    _;
    _('#### Low-level exception detected');
    _(format('Exception address: %p',[exceptaddr]));
    _(format('Exception object: %p',[exceptObject]));
    _(format('Exception object class: %s',[exceptObject.classname]));
    if (exceptObject<>nil) and (exceptObject is TControl) then
    _(format('Exception object name: %s',[(exceptObject as tcontrol).name]));
    _;


end;

function ExceptionFilter(const EP : TExceptionPointers) : Integer; stdcall;
begin
 with EP.ContextRecord^ do
  begin
    _('@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
    _('@@@ Unhandled exception detected!!!!');
//    system.


    _(format('@@@ Exception address: %p',[ep.ExceptionRecord^.ExceptionAddress]));
    _(format('@@@ Exception flags: %p',[ep.ExceptionRecord^.ExceptionFlags]));
    case
    ep.ExceptionRecord^.ExceptionCode of

EXCEPTION_ACCESS_VIOLATION:
_('The thread tried to read from or write to a virtual address for which it does not have the appropriate access.');
EXCEPTION_ARRAY_BOUNDS_EXCEEDED:
_('The thread tried to access an array element that is out of bounds and the underlying hardware supports bounds checking.');
EXCEPTION_BREAKPOINT:
_('A breakpoint was encountered.');
EXCEPTION_DATATYPE_MISALIGNMENT:
_('The thread tried to read or write data that is misaligned on hardware that does not provide alignment. For example, 16-bit values must be aligned on 2-byte boundaries; 32-bit values on 4-byte boundaries, and so on.');
EXCEPTION_FLT_DENORMAL_OPERAND:
_('One of the operands in a floating-point operation is denormal. A denormal value is one that is too small to represent as a standard floating-point value.');
EXCEPTION_FLT_DIVIDE_BY_ZERO:
_('The thread tried to divide a floating-point value by a floating-point divisor of zero.');
EXCEPTION_FLT_INEXACT_RESULT:
_('The result of a floating-point operation cannot be represented exactly as a decimal fraction.');
EXCEPTION_FLT_INVALID_OPERATION:
_('This exception represents any floating-point exception not included in this list.');
EXCEPTION_FLT_OVERFLOW:
_('The exponent of a floating-point operation is greater than the magnitude allowed by the corresponding type.');
 EXCEPTION_FLT_STACK_CHECK:
_('The stack overflowed or underflowed as the result of a floating-point operation.');
EXCEPTION_FLT_UNDERFLOW:
_('The exponent of a floating-point operation is less than the magnitude allowed by the corresponding type.');
EXCEPTION_ILLEGAL_INSTRUCTION:
_('The thread tried to execute an invalid instruction.');
EXCEPTION_IN_PAGE_ERROR:
_('The thread tried to access a page that was not present, and the system was unable to load the page. For example, this exception might occur if a network connection is lost while running a program over the network.');
EXCEPTION_INT_DIVIDE_BY_ZERO:
_('The thread tried to divide an integer value by an integer divisor of zero.');
EXCEPTION_INT_OVERFLOW:
_('The result of an integer operation caused a carry out of the most significant bit of the result.');
EXCEPTION_INVALID_DISPOSITION:
_('An exception handler returned an invalid disposition to the exception dispatcher. Programmers using a high-level language such as C should never encounter this exception.');
EXCEPTION_NONCONTINUABLE_EXCEPTION:
_('The thread tried to continue execution after a noncontinuable exception occurred.');
EXCEPTION_PRIV_INSTRUCTION:
_('The thread tried to execute an instruction whose operation is not allowed in the current machine mode.');
EXCEPTION_SINGLE_STEP:
_('A trace trap or other single-instruction mechanism signaled that one instruction has been executed.');
EXCEPTION_STACK_OVERFLOW:
_('The thread used up its stack.');
else _('Unknown exception');

    end;
//    _('@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');

{   Writeln('eip = ',eip);
   Writeln('ebp = ',ebp);
   Writeln('esp = ',esp);
   Writeln('eflags = ',eflags);}
   _(SysErrorMessage(ep.ExceptionRecord.ExceptionCode));
  end;
 Result:=0; // = EXCEPTION_CONTINUE_SEARCH
end;


initialization
    ExceptProc:=@umcExceptLowHandler;
    SetUnhandledExceptionFilter(@ExceptionFilter);


end.

