unit UMCparanoia;

interface
uses classes, forms, UMC_Z, dateutils, unistorage;
var madcounter:integer=1;
const mad_fname='Words';
      mad_chars='Charsets';
      mad_ma='Mailers';
      mad_rc='Recipients';
      mad_sd='Senders';
      mad_keys='Keys';
      s_spam='Spam';
      s_nonspam='NonSpam';
      mad_macros='Macros';
      //mad_test='Test&Debug';
      mad_Traffic='Traffic';
      mad_sip='Sender_IP';
      mad_sserver='Sender_Server';
      mad_servers='Servers';
      mad_sndname='SenderNames';
      mad_rcpname='RecipientName';
      mad_ISP='DialUp';
    MadDelimiter:array[1..4] of string=('0A','0D0A','0D','0A0D');
type
     MadDel=(_0a=1,_0d0a=2,_0d=3,_0a0d=4);
type TParaDaemonSorter=class(Tthread)
    procedure Execute;override;
//    procedure Sort;
//    procedure SetFileName(fname:string);
    constructor Create(CreateSuspended: Boolean);
//    function GetBuf:string;
    public
    no,elNum,nOffset:integer;
    mode,need2sort:boolean;
    storage:TZStorage;
end;

type TParaDaemon=class(Tobject)
//    constructor Create;
    procedure Eat(s:string;mode:boolean=false);
    procedure FastEat(s:string;minlen:integer;mode:boolean=false;size:integer=-1);
    procedure ProcessText(s:string;minlen:integer;mode:boolean=false;size:integer=-1);
    procedure ProcessTree(Tree:TUniTree);
    procedure Execute;//override;
//    procedure AssignSorter(srt:TParaDaemonSorter);
    procedure Stop;
    function state:string;
    function ValidateHeader(s:string):boolean;
    procedure StoreTo(FullText,FileMask:string);
    procedure AddLetter(Fulltext,Headers:string);
    function need2process:boolean;
//    procedure Sort;
//    procedure SortLoop(filename:string);
    procedure Clear;
    procedure SetDelimiter(NewDel:MadDel);
    procedure OnTerminate(Sender:TObject);
//    procedure SetFileName(Filename:string);
    constructor Create(CreateSuspended: Boolean;filename:string);
    procedure CheckOff;
    procedure CheckOffButLen;
    procedure Store;
    procedure free;
    function GetWordCount:integer;
    function GetWordFreq(w:string):integer;
    public
    sorter:TParaDaemonSorter;
    private
    need2sort:boolean;
    buf1:string;
    del:MadDel;
    ch4len,running,need2check:boolean;
    _mad_fname:string;
    no:integer;
//    storage:TZStorage;
end;

const maxstats=16;
      Mad=0;
      MadCharset=1;
      MadMailer=2;
      Madsender=3;
      Madrecipient=4;
      //Mad4=5;
      Madspam=6;
      Madnonspam=7;
      //Madm=8;
      Madtraffic=9;
      Madsip=10;
      Madsname=11;
      Madrname=12;
      Madisp=13;
      Madserver=14;
      Madservers=15;
const madnames:array[0..maxstats] of string=(
mad_fname,mad_chars,mad_ma,mad_rc,mad_sd,mad_keys,s_spam,s_nonspam,mad_macros,mad_traffic
,mad_sip,mad_sndname,mad_rcpname,mad_ISP,mad_sserver,mad_servers,'Special');
var Stats:array[0..maxstats] of TParaDaemon;
 
procedure SMD(n:integer;mode:boolean=true);
procedure ProcessAllMads(mode:boolean);
procedure SaveAllMads;
procedure SortAllMads;
procedure _SMD(n:integer;mode:boolean=true);
procedure CO(n:integer);

implementation

uses UMClogger, inifiles, UMCaux, sysutils, UMCsyntax, UMCfuntions,
  UMClanguages, UMCsetupform, windows{, unistorage};

{ TParaDaemon }

procedure CO(n:integer);
begin
        try
        if stats[n]<>nil then stats[n].CheckOff;
        except
        end;
end;
procedure SMD(n:integer;mode:boolean=true);
begin
//    _('Storing mad data');
    if stats[n]<>nil then begin
        if mode then
            try
                if stats[n].sorter.storage.modified then
                stats[n].sorter.Execute;
            except
                _('***** ERROR!!! Failed to sort mad data');
            end
        else
            try
                stats[n].Store;
            except
                _('***** ERROR!!! Failed to store mad data');
            end;
    end;
//    else _('***** ERROR!!! Trying to store empty mad; aborted');
end;

procedure _SMD(n:integer;mode:boolean=true);
begin
    try
        SMD(n,mode);
    except
        _('Warning! Unsafe exception detected when saving mad!');
    end;
end;
procedure SortAllMads;
begin
    ProcessAllMads(false);
end;
procedure SaveAllMads;
begin
    ProcessAllMads(true);
end;
procedure ProcessAllMads(mode:boolean);
begin
//    if connectionstate=1 then exit;
//    _('Saving all the mads');
    _SMD(madCharset,mode);
    _SMD(madmailer,mode);
    _SMD(madrecipient,mode);
    _SMD(madsender,mode);
    if sCountSpam then begin
    _SMD(madnonspam,mode);
    _SMD(madspam,mode);
    end;
//    _SMD(madm,mode);
    _SMD(madtraffic,mode);
    _SMD(mad,mode);
    _SMD(madsip,mode);
    _SMD(madserver,mode);
    _SMD(madservers,mode);
    _SMD(madsname,mode);
    _SMD(madrname,mode);
    _SMD(madisp,false);
//    _('All mads saved');
end;

procedure TParaDaemon.AddLetter(Fulltext, Headers: string);
begin
    if validateheader(headers) then Storeto(fulltext,madmask);
end;

procedure TParaDaemon.CheckOff;
begin
    need2check:=false;
    ch4len:=false;
end;

procedure TParaDaemon.CheckOffButLen;
begin
    need2check:=false;
    ch4len:=true;
end;

procedure TParaDaemon.Clear;
begin
    while fileexists(_mad_fname) do sysutils.deletefile(_mad_fname);
    need2sort:=false;
    sorter.storage.clear;
    _('The mad #'+inttostr(no)+': "statistics deleted"');
end;

constructor TParaDaemon.Create(CreateSuspended: Boolean;filename:string);
begin
    need2check:=true;
    ch4len:=true;
    sorter:=TParaDaemonSorter.Create(true);
    no:=madcounter;
    sorter.no:=no;
    inc(madcounter);
    buf1:='';
    need2sort:=true;
    del:=_0a;
    sorter.storage:=tzstorage.create;
    _mad_fname:=filename;
    sorter.storage.Load(filename);
    inherited Create;//(CreateSuspended);
end;

procedure TParaDaemon.Eat(s: string;mode:boolean=false);
var i:integer;
begin
    _('enter eat');
//    EnterCriticalSection(cs2);
    if mode then for i:=1 to length(s) do if s[i] in ['a'..'z','A'..'Z'] then s[i]:=' ';
    need2sort:=true;
    buf1:=buf1+s;
//    _('The mad #'+inttostr(no)+': "Eated '+inttostr(length(s))+' bytes ');
//    LeaveCriticalSection(cs2);
    _('leave eat');
end;

procedure TParaDaemon.Execute;
begin
        //priority:=tpIdle;
    if buf1='' then exit;
    if (running) then exit;
    running:=true;

        if buf1<>'' then begin
            self.fasteat(buf1,stminlen);

            buf1:='';

        end;

    running:=false;
end;

procedure TParaDaemon.FastEat(s:string;minlen:integer;mode:boolean=false;size:integer=-1);
//procedure TParaDaemon.FastEat(s:string;minlen:integer);
{var i,b,k:integer;
//    f:tdatetime;
    cnt:integer;
    addtime,proctime,n:cardinal;
    ns:TParaDaemonSorter;//TZStorage;}
begin
    _('WARNING: fasteat is obsolete now. using processtext instead');
    ProcessText(s,minlen,mode,size);
    exit;
{    _('enter Fasteat');
    if _t>1 then begin
        _('@@@@ Rejecting nested eats!');
        self.Eat(s,mode);
        exit;
    end;

//    f:=now;
    cnt:=0;
    ns:=TParaDaemonSorter.create(true);
    ns.storage:=tzstorage.create;

//    n.
    addtime:=0;
    proctime:=0;
    n:=gettickcount;
//    _('The mad #'+inttostr(no)+' is preparing to eat '+inttostr(length(s))+' bytes');
    s:=' '+s+' ';
    if mode then for i:=1 to length(s) do if s[i] in ['a'..'z','A'..'Z'] then s[i]:=' ';
//    _('1');
    b:=1;
    i:=0;
    k:=0;
    repeat
        inc(i);
//        _(inttostr(i));
        if not(
        ((s[i]>='@')and(s[i]<='Z'))
        or
        ((s[i]>='a')and(s[i]<='z'))
        or
        (s[i]>='')
        or
        (s[i]='')
        or
        (s[i]='')
        ) then begin
//        if (byte(s[i])<=32)or(s[i] in ['.',',',':','-','!','?',';','''','(',')','/','\','=','>','<']) then begin
            if (i-b>=minlen+1) and (i-b<maxwl) then begin
                addtime:=addtime+gettickcount-n;
                n:=gettickcount;

                if i-b>=stMinLen then begin
                    if size=-1 then
                        cnt:=cnt+ns.storage.incS(copy(s,b+1,i-b-1))
                    else
                        cnt:=cnt+ns.storage.incS(copy(s,b+1,i-b-1),size);
                end;
                //sorter.storage.incS(copy(s,b+1,i-b-1));

                proctime:=proctime+gettickcount-n;
                n:=gettickcount;
                inc(k);
            end;
            b:=i;
        end;
    until i>=length(s)-1;



    if k<>0 then begin
        _('The mad #'+inttostr(no)+' fast ate '+inttostr(k)+' entries, '+inttostr(ns.storage.cnt)+' unique');
        _('Total cycles: '+inttostr(cnt)+', average: '+floattostr(cnt/k));
    end;

    for i:=1 to ns.storage.cnt do begin

       sorter.storage.incS(ns.storage.dataS(i));
        end;

    ns.Execute;

    ns.storage.free;
    ns.free;

    _('leave Fasteat');}
end;

procedure TParaDaemon.free;
begin
    if self=nil then exit;
{    _(format('Self: %p',[@self]));
    _(format('Sorter: %p',[@sorter]));
    _(format('Storage: %p',[@sorter.storage]));
    _(inttostr(sorter.storage.cnt));
    try
    sorter.storage.SaveToZFile(_mad_fname+ext);
    except
    _('Error storing data');
    end;
    sorter.Terminate;}
    try
    if sorter<> nil then begin
        if sorter.storage<>nil then
        sorter.storage.free;
        sorter.Free;
    end;
    except
    _('Error freeing storage');
    end;
    inherited free;
end;

function TParaDaemon.GetWordCount: integer;
begin
    result:=sorter.storage.wcnt;
end;

function TParaDaemon.GetWordFreq(w: string): integer;
begin
    result:=sorter.storage.getSV(w);
end;

function TParaDaemon.need2process: boolean;
begin
    result:=buf1<>'';
end;

procedure TParaDaemon.OnTerminate(Sender: TObject);
begin
//    _('About to terminate');
//    Terminate;
end;

procedure TParaDaemon.ProcessText(s: string; minlen: integer;
  mode: boolean; size: integer);
var i:integer;
    n:TUniTree;
begin
        try
//    _('Creating object');
    n:=TUniTree.Create;
//    _('Eliminating chars');
    if mode then for i:=1 to length(s) do if s[i] in ['a'..'z','A'..'Z'] then s[i]:=' ';
//    _('Setting length');
    n.SetMinLen(minlen);
//    _('Adding text');
    try
    n.AddText(s,size);
    except
        _('Exception while adding text ');
    end;
//    _('Processing tree');
    ProcessTree(n);
//    _('Freeing object');
    try
    n.Free;
    except
    end;
        except
        end;
//    _('Exiting');
end;

procedure TParaDaemon.ProcessTree(Tree: TUniTree);
var i:integer;
begin
    if Tree.isdata then sorter.storage._IncS(tree.data.str,tree.data.size){ TODO 5 -o -cstats : !change this! }; {warn}
    for i:=32 to 255 do if Tree.l[i]<>nil then ProcessTree(Tree.l[i]^);

end;

procedure TParaDaemon.SetDelimiter(NewDel: MadDel);
begin
    del:=NewDel;
end;

function TParaDaemon.state: string;
begin
    if running then result:=o[70] else result:=o[71];
end;

procedure TParaDaemon.Stop;
begin
//    ef:=true;
//    Terminate;
end;

procedure TParaDaemon.Store;
begin
    try
    if sorter.storage.modified then begin

//    _('The mad #'+inttostr(no)+' storing to '+_mad_fname+ext);
    _('Storing '+_mad_fname+ext+'...');
    sorter.storage.SaveToZFile(_mad_fname+ext);
    _('DOne storing');
//    _('Done');
    end;
//     else    _('The mad #'+inttostr(no)+' is not modified; skipped');
    except
    _('***** ERROR!!! Can''t store mad');
    end;

end;

procedure TParaDaemon.StoreTo(FullText, FileMask: string);
var s:string;
    f:textfile;
    n:tstringlist;
    i:integer;
    dl:string;
begin
    case del of
        _0a:dl:=#$0a;
        _0d:dl:=#$0d;
        _0a0d:dl:=#$0a#$0d;
        _0d0a:dl:=#$0d#$0a;
    else
        dl:=#$0a;
    end;
    s:=SynEvalVar(FileMask);
    _('The mad #'+inttostr(no)+': "Storing '+inttostr(length(fulltext))+' bytes to '+s+'"');
    if not fileexists(s) then begin
        assignfile(f,s);
        rewrite(f);
        closefile(f);
    end;
    assignfile(f,s);
    append(f);
    n:=tstringlist.Create;
    n.Text:=FullText;
    write(f,GetFirstHeader(fulltext,'From:')+dl);
    for i:=0 to n.count-1 do begin
        if (pos('From',n.strings[i]))=1 then
            n.Strings[i]:='>'+n.Strings[i];
        write(f,n.strings[i]+dl);
    end;
    n.Free;
    closefile(f);

end;

function TParaDaemon.ValidateHeader(s: string): boolean;
begin
    result:=not((pos(ansiuppercase(madignorestr),ansiuppercase(s))>0)and(maddoignore));

end;

{ TParaDaemonSorter }
type nz=array[0..0] of pchar;
     pnz=^nz;

procedure TParaDaemonSorter.Execute;
var //tlist,slist:tstringlist;
    i:integer;
//    t1,t2:string;
{    v1,v2,c,}cnt:integer;
    j:integer;
    bSorted:boolean;
    sh1,sh2:TStringHolder;
begin
//    _('Mad #'+inttostr(no)+'Sorting...');
//    z:=0;
//    c:=0;
        priority:=tpIdle;
    try
        cnt:=storage.cnt;//        slist.Count;

    nOffset:=cnt;//slist.Count-1;
    elNum:=cnt;//slist.Count-1;
//    _(cnt);

    repeat
          nOffset:=(nOffset*8) div 11;
          if nOffset<1 then nOffset:=1;
          bSorted:=true;
          i:=0;
          j:=nOffset;

          while (i<(elNum-nOffset)) do begin
          if terminated then exit;
                inc(i);
                inc(j);

{                if (storage.pdata^[i-1]^.val<storage.pdata^[j-1]^.val) then begin
                    storage.swapdata(i-1,j-1);
                   bSorted:=false;
                end;}
                if (storage.dataS(i-1)=storage.dataS(j-1))and(storage.dataS(j-1)<>'') then begin
           //         _('Duplicates found: ['+sh1.str+']');
                    sh1:=storage._getitem(i-1);
                    sh2:=storage._getitem(j-1);
                 {   _('+ times : '+datetimetostr(sh1.stamp)+' '+datetimetostr(sh2.stamp));
                    _('+ times2: '+datetimetostr(sh1.stamp2)+' '+datetimetostr(sh2.stamp2));
                    _('+ vals  : '+inttostr(sh1.val)+' '+inttostr(sh2.val));
                    _('+ sizes : '+inttostr(sh1.size)+' '+inttostr(sh2.size));  }
                    storage.killitem(j-1);
//                    sh1.size:=sh1.size+sh2.size;
//                  sh1.val:=sh1.val+sh2.val;
                    inc(sh1.size,sh2.size);
                    inc(sh1.val,sh2.val);
                    if sh1.stamp>sh2.stamp then sh1.stamp:=sh2.stamp;
                    if sh1.stamp2<sh2.stamp2 then sh1.stamp2:=sh2.stamp2;
               {     _('- times : '+datetimetostr(sh1.stamp));
                    _('- times2: '+datetimetostr(sh1.stamp2));
                    _('- vals  : '+inttostr(sh1.val));
                    _('- sizes : '+inttostr(sh1.size));     }

                    storage._setitem(i-1,sh1);
                       bSorted:=false;
                end else begin
                if mode then begin
                    if (storage.dataV(i-1)<storage.dataV(j-1)) then begin
                        storage.swapdata(i-1,j-1);
                        bSorted:=false;
                    end;
                end else begin
                    if (storage.dataSize(i-1)<storage.dataSize(j-1)) then begin
                        storage.swapdata(i-1,j-1);
                        bSorted:=false;
                    end;
                end;
                end;
          end;

    until bSorted and (nOffset=1);
    except
    _('Exception while sorting in #'+inttostr(no));
    end;
{    if c<>0 then
    _('Sorting performed in mad #'+inttostr(no)+' : '+inttostr(c)+' times');}

    need2sort:=false;
//    _('Finished sorting');
end;

constructor TParaDaemonSorter.Create(CreateSuspended: Boolean);
begin
    inherited;
    mode:=true;
end;

end.


