unit UMCparser;

interface
uses sysutils;
const atomops=['*','+','-','/'];  // 

const alph=['%','A'..'Z','0'..'9','_']; // 
const num=['0'..'9'];
const oquot='';
const cquot='';


const bracketO=['[']; //. 
const bracketC=[']']; //.


const brackets=bracketO+bracketC;  //

function DivStr(str1,str2:string):string;
procedure DeQuote(var s:string);
procedure Quote(var s:string);
procedure swap(var a,b:string);
function eval(str:string):string;
function evalstr(str:string):string;
function proc(s:string):string;
function isatom(s:string):boolean;
function evalatoms(str:string):string;
type mtStatus=(
mtNone,     // 
mtIdent,    // 
mtParamsW,  // 
mtParams,   // 
mtStrW,      // 
mtDone      // 
);

implementation

uses UMClanguages, UMCvar;
function proc(s:string):string;
var i:integer;
begin
    for i:=1 to length(s) do
        if s[i]=oquot then s[i]:='<' else
        if s[i]=cquot then s[i]:='>';
    result:=s;
end;

function evalstr(str:string):string;
begin
    if str='' then begin
        result:=oquot+cquot;
    end;
    if str[1]='%' then begin
        str:=copy(str,2,length(str)-1);
        case vartype(str) of
            uUnk:result:=oquot+cquot;
            uStr:result:=oquot+proc(GetVar(str))+cquot;
            uInt:result:=GetVar(str);
        end;
    end;
end;
function isatom(s:string):boolean;
var k:integer;
    st:mtStatus;
    par,op:integer;
begin
    st:=mtNone;
    k:=0;
    result:=true;
    par:=0;
    op:=0;
{mtNone,     // 
mtIdent,    // 
mtParamsW,  // 
mtParams,   // 
mtDone      // }
    repeat
        inc(k);
        if (s[k] in atomops-['-'])and (st<>mtStrW) then begin
           st:=mtNone;
           inc(op);
        end;
        if (st<>mtStrW)and(s[k]='%') then begin
           result:=false;
           exit;
        end;
        case st of
            mtNone:if s[k]=oquot then st:=mtStrW else
                if s[k] in num+['-'] then st:=mtIdent;
            mtIdent:if not(s[k] in num) then begin
                inc(par);
                st:=mtNone;
            end;
            mtStrW:if s[k]=cquot then begin
                inc(par);
                st:=mtNone;
            end;
        end;
        if (par>2) or (op>1) then begin
           result:=false;
           exit;
        end;
    until k=length(s);

end;
function evalatoms(str:string):string;
var b,e,i,j:integer;
    ns:boolean;
    k:integer;
begin
    result:=str;
      if isatom(str) then begin
        result:=eval(str);
        exit;
      end;
      ns:=true;
      b:=pos('(',str);
      e:=0;
      if b>0 then begin
        for i:=b to length(str) do begin
            if str[i]=oquot then ns:=false;
            if not ns and (str[i]=cquot) then ns:=false;

            if ns then
            if str[i]='(' then b:=i else
            if str[i]=')' then begin
                e:=i;
                break;
            end;
        end;
      if e<>0 then begin
        k:=findvar('Temp');
        addvar('Temp',copy(str,1,b-1)+'{'+copy(str,b+1,e-b-1)+'}'+copy(str,e+1,length(str)-e)+' '+' '+vars[k].datas);
        result:=
            evalatoms(copy(str,1,b-1)+
            eval(copy(str,b+1,e-b-1))+
            copy(str,e+1,length(str)-e));
            exit;
            end;
      end;
      b:=1;
      for i:=1 to length(str) do begin
            if str[i]=oquot then ns:=false;
            if not ns and (str[i]=cquot) then ns:=false;
            if ns then
            if str[i] in ['+','-'] then b:=i;
            if str[i] in ['*','/'] then begin
                j:=i;
                inc(j);
                if j=length(str) then result:=copy(str,1,length(str)-1);
                if str[j] in num then begin
                    repeat inc(j) until not(str[j] in num) or (j=length(str));
                end else if str[j]=oquot then begin
                    repeat inc(j) until (str[j]=cquot) or (j=length(str));
                end;

        k:=findvar('Temp');
        addvar('Temp',copy(str,1,b)+'{'+copy(str,b,e-b)+'}'+copy(str,e,length(str)-e)+' '+' '+vars[k].datas);
        result:=
            evalatoms(copy(str,1,b)+
            eval(copy(str,b,e-b))+
            copy(str,e,length(str)-e));
            exit;
            end;
      end;

end;

procedure DeQuote(var s:string);
begin
    if s[1]=oquot then s:=copy(s,2,length(s)-1);
    if s[length(s)]=cquot then s:=copy(s,1,length(s)-1);
end;
function DivStr(str1,str2:string):string;
var c:set of char;
    i:integer;
    s:string;
begin
    s:='';
    c:=[];
    for i:=1 to length(str2) do c:=c+[str1[i]];
    for i:=1 to length(str1) do if not(str1[i] in c) then s:=s+str1[i];
    result:=s;
end;
procedure Quote(var s:string);
begin
    if s[1]<>oquot then s:=oquot+s;
    if s[length(s)]<>cquot then s:=s+cquot;
end;
procedure swap(var a,b:string);
var c:string;
begin
    c:=a;
    a:=b;
    b:=c;
end;
function eval(str:string):string;
var //s:string;
    str1,str2:string;
    oppos:integer;
    i:integer;
    b:boolean;
    i1,i2:integer;

begin
    b:=true;
    oppos:=0;
    for i:=1 to length(str) do begin
        if b and (str[i] in atomops) then begin
             oppos:=i;
             break;
        end;
        if str[i]=oquot then b:=false;
        if str[i]=cquot then b:=true;
    end;
    if oppos=0 then begin
        result:=str;
        exit;
    end;
    if oppos=length(str) then begin
        result:=copy(str,1,length(str)-1);
        if result='' then result:=oquot+cquot;
        exit;
    end;
    if oppos=1 then begin
        result:=copy(str,2,length(str)-1);
        if str[1]<>'-' then exit;
        oppos:=0;
        for i:=2 to length(str) do begin
            if b and (str[i] in atomops) then begin
                oppos:=i;
                break;
            end;
            if str[i]=oquot then b:=false;
            if str[i]=cquot then b:=true;
        end;
        if oppos=0 then exit;
    end;
    str1:=copy(str,1,oppos-1);
    str2:=copy(str,oppos+1,length(str)-oppos);

    if (pos(oquot,str1)=0) and (pos(oquot,str2)=0) then begin
        try
            i1:=strtoint(str1);
        except
            i1:=0;
        end;
        try
            i2:=strtoint(str2);
        except
            i2:=0;
        end;
        case str[oppos] of
            '+':result:=inttostr(i1+i2);
            '-':result:=inttostr(i1-i2);
            '*':result:=inttostr(i1*i2);
            '/':if i2<>0 then result:=inttostr(i1 div i2)
            else result:=oquot+o[93]+cquot;
        end;
        if result='' then result:=oquot+cquot;
        exit;
    end;
    Quote(str1);
    Quote(str2);
    case str[oppos] of
        '+','*':result:=copy(str1,1,length(str1)-1)+copy(str2,2,length(str2)-1);
        '-','/':result:=DivStr(str1,str2);
    end;
    Quote(result);
end;

end.
 