unit UMCsyntax;
interface
uses sysutils, classes, UMCvar,forms,UMClanguages;

const synMinusVal=['+','-','*','(','/'];
      synSpecificchars=['+','-','*','/','(',')',','];
      synletters=['a'..'z','A'..'Z','_'];
      synnumbers=['0'..'9'];
      synOps=['+','-','/','*'];
function synDoSpaces(s:string):string; //   
function synEvalVars(s:string):string; //   
function synEvalVar(s:string):string; //      
function synEvalMacro(s:string):string;overload; //  
function synProc(s:string):string;overload; //  
function synExtr(s:string):Tstringlist; // 
function synPack(var n:Tstringlist):string; // 
function synEvalTokens(s:string):string; //     .
function synExtrN(s:string;First,Last:integer):string; //   First  Last
function synQuote(s:string):string; // 
function synDeQuote(s:string):string; // 
function synEvalExpr(s:string):double;
implementation

uses UMClogger, jclexpreval;

function synEvalExpr(s:string):double;
var j:TEvaluator;
begin
     j:=TEvaluator.Create;
     result:=j.Evaluate(synevalvar(s));
     j.Free;
end;

function synQuote(s:string):string;
begin
    if s='' then begin
        result:='""';
        exit;
    end;
    if s[1]<>'"' then s:='"'+s;
    if s[length(s)]<>'"' then s:=s+'"';
    result:=s;
end;
function synDeQuote(s:string):string;
begin
    if s='' then begin
        result:='';
        exit;
    end;
    if s[1]='"' then s:=copy(s,2,length(s)-1);
    if s[length(s)]='"' then s:=copy(s,1,length(s)-1);
    if s[1]='''' then s:=copy(s,2,length(s)-1);
    if s[length(s)]='''' then s:=copy(s,1,length(s)-1);
    result:=s;
end;
function synExtrN(s:string;First,Last:integer):string;
var n:tstringlist;
    i:integer;
begin
    result:='';
    if last<first then exit;
    n:=synExtr(s);
    for i:=0 to n.Count-1 do
        if (i<First) or (i>Last) then n.Strings[i]:='';
    result:=SynPack(n);
end;
function synEvalTokens(s:string):string;
var n:tstringlist;
    i,b,e,j:integer;
    isint1,isint2:boolean;
    c,i1,i2:integer;
    s1,s2,s3:string;
    k,kb:integer;

begin
    _('Evaluating tokens: '+s);
    if s='' then begin
        result:='';
        exit;
    end;
    n:=synExtr(s);
    k:=0;
    kb:=0;
    if (n.Strings[0]='(') and (n.Strings[n.Count-1]=')') then begin
        for i:=0 to n.Count-1 do begin
            if n.Strings[i][1] in ['(',')'] then inc(k);
            if n.Strings[i]='(' then inc(kb);
            if n.Strings[i]=')' then dec(kb);
            end;
        if kb<>0 then begin
            result:=synQuote(o[97]);
            n.Free;
            exit;
        end;
        if k=2 then begin
            _('k=2');
            result:=' '+trim(synEvalTokens(synExtrN(s,1,n.Count-2)))+' ';
            n.Free;
            exit;
        end;
    end;
    if n.Count=1 then begin
        result:=s;
        n.free;
        exit;
    end;
    if {(n.Count=2) and }(n.strings[0][1] in synops) then begin
        isint1:=(n.Strings[1]<>'') and (n.Strings[1][1]<>'"');
        if isint1 then begin
            case n.strings[0][1] of
                '+':begin
                    _('+');
                    result:=synEvalTokens(synextrn(s,1,n.Count-1));
                end;
                '-':begin
                    _('-');
                    result:=synEvalTokens('-'+synextrn(s,1,n.Count-1));
                end;
                '*','/':begin
                    _('*/');
                    result:='0'+synEvalTokens(synextrn(s,2,n.Count-1));
                end;
            end;
        end else begin
            _('else');
            result:=synEvalTokens(synextrn(s,1,n.Count-1));
        end;
        n.Free;
        exit;
    end;
    if n.count<=2 then begin
        result:=synPack(n);
        exit;
    end;
    for i:=0 to n.Count-1 do
        if n.Strings[i]='(' then begin
            b:=i;
            for j:=i+1 to n.Count-1 do begin
                if n.Strings[j]='(' then b:=j;
                if n.Strings[j]=')' then begin
                    e:=j;
                    _(')');
                    result:=synEvalTokens(synExtrN(s,0,b-1)+synEvalTokens(synExtrN(s,b,e))+synExtrN(s,e+1,n.Count-1));
                    n.Free;
                    exit;
                end;
            end;
        end;
    if (n.Count=3) and (n.Strings[1][1]=',') then begin
        result:=synProc(n.Strings[0])+' , '+synProc(n.Strings[2]);
        n.Free;
        exit;
    end;
    if (n.Count=3) and (n.Strings[1][1] in synOps) then begin
        isint1:=(n.Strings[0]<>'') and (n.Strings[0][1]<>'"');
        isint2:=(n.Strings[2]<>'') and (n.Strings[2][1]<>'"');
        if isint1 and isint2 then begin
            val(n.Strings[0],i1,c);
            if c<>0 then i1:=0;
            val(n.Strings[2],i2,c);
            if c<>0 then i2:=0;
            case n.Strings[1][1] of
                '+':result:=inttostr(i1+i2);
                '-':result:=inttostr(i1-i2);
                '*':result:=inttostr(i1*i2);
                '/':if i2<>0 then
                    result:=inttostr(i1 div i2)
                else
                    result:=synQuote(o[93]);
            end;
        end else begin
            n.Strings[0]:=synQuote(n.Strings[0]);
            n.Strings[2]:=synQuote(n.Strings[2]);
            result:=copy(n.Strings[0],1,length(n.Strings[0])-1)+copy(n.Strings[2],2,length(n.Strings[0])-1);
        end;
        n.Free;
        exit;
    end;
    for i:=1 to n.Count-1 do
        if n.Strings[i][1] in synops then begin
            b:=i-1;
            e:=i+1;
            s1:=synExtrN(s,0,b-1);
            s2:=synExtrN(s,b,e);
            s3:=synextrN(s,e+1,n.Count-1);
            _('synops');
            result:=synEvalTokens(s1+' '+synEvalTokens(s2)+' '+s3);
            n.Free;
            exit;
        end;
    _('...');
    result:=synDoSpaces(s);
//    result:=synDoSpaces(synEvalTokens(s));
    n.Free;

    _('Result evaluating tokens: '+result);
end;

function synPack(var n:Tstringlist):string; // 
var i:integer;
begin
    result:='';
    for i:=0 to n.Count-1 do
        result:=trim(result+' '+n.Strings[i]);
    n.Free;
end;

function synEvalMacro(s:string):string; //  
var n:Tstringlist;
    i,j:integer;
    ts:string;
begin
    _('Evaluating macro_tmp: '+s);
    n:=synextr(s);
    for i:=0 to n.Count-1 do
        if pos('$',n.Strings[i])=1 then begin
            if pos('(',n.Strings[i])=length(n.Strings[i]) then
                for j:=i+1 to n.Count-1 do begin
                    ts:=n.Strings[j];
                    n.Strings[i]:=n.Strings[i]+ts;
                    n.Strings[j]:='';
                    if ts=')' then break;
                end;
            n.Strings[i]:='"'+n.Strings[i]+'"';
            end;
    result:=synpack(n);
    _('Result evaluating macro: '+result);
end;
function synProc(s:string):string;
begin
    result:=synEvalTokens(synEvalMacro(synEvalVars(SynDoSpaces(s))));
end;
function synExtr(s:string):Tstringlist;
var n:Tstringlist;
begin
    n:=Tstringlist.Create;
    ExtractStrings([' '],[],pchar(s),n);
    result:=n;
end;
function synEvalVar(s:string):string;
var b,e:integer;
    vr:string;
begin
//    _('in: '+s);
    result:=s;
    s:=s+' ';
    b:=pos('$$',s);
    e:=b+2;
    while (e<length(s)) and (s[e] in synLetters) do inc(e);
    vr:=copy(s,b+2,e-b-2);
//    _('>>> '+vr);
    if b=0 then exit;
    result:=trim(synevalvar(copy(s,1,b-1)+GetVar(vr)+copy(s,e,length(s)-e+1)));

//    _('out: '+result);

end;
function synEvalVars(s:string):string;
var n:Tstringlist;
    i:integer;
    ts:string;
    nq:boolean;
begin
    nq:=false;
    _('Evaluating vars: '+s);
    n:=synExtr(s);
    result:='';
    for i:=0 to n.Count-1 do
        if pos('$$',n.Strings[i])=1 then begin
            ts:=copy(n.Strings[i],3,length(n.Strings[i])-2);
            case VarType(ts) of
                uStr:begin
                    n.Strings[i]:=GetVar(ts);
                    nq:=true;
                end;
                uInt:n.Strings[i]:=GetVar(ts);
            else
                n.Strings[i]:='';
            end;
        end;
    for i:=0 to n.Count-1 do
        result:=trim(result+' '+n.Strings[i]);
    n.Free;
    if nq then result:=synQuote(result);
    _('Result evaluating vars: '+result);
end;
function synDoSpaces(s:string):string;
var rs:string;
        i:integer;
        isquot:boolean;
        isid:boolean;
begin
    _('Dospaces: '+s);
    rs:='';
    s:=' '+s+'  ';
    isquot:=false;
    isid:=true;
    i:=0;
    repeat
        inc(i);
//    for i:=1 to length(s)-1 do begin
        if s[i]='"' then begin
            isquot:=true;
            inc(i);
            rs:=rs+'"';
            _('ISQUOT: '+copy(s,1,i));
        end;
        if isid and (s[i]='(') and (s[i-1]='(') then isid:=false;
        if isid and not(s[i] in synletters) and (s[i]<>'(') then isid:=false;
        if s[i]='$' then isid:=true;
        if isquot and (s[i]='"') and (s[i+1]<>'"') then begin
            rs:=rs+'"';
            isquot:=false;
            _('NOQUOT: '+copy(s,1,i));
        end;
        if not isquot and (s[i] in synSpecificChars) then begin
            if isid then
            rs:=trim(rs)+s[i]+' '
            else if (s[i]='-') and (s[i+1] in synnumbers) and (s[i-1] in synminusval)
            then rs:=trim(rs)+' '+s[i] else
            rs:=trim(rs)+' '+s[i]+' ';
        end
        else rs:=rs+s[i];
    until i>length(s)-2;
//    end;
    result:=rs;
    _('Dospaces result: '+result);
end;

end.
