unit UMCvar;

interface
uses inifiles, sysutils, classes;
const maxvar=100;
type tuvar=(uStr,uInt,uUnk);
    varrec=object
        used:boolean;
        name:string;
        datas:string;
        datai:integer;
        vtype:tuvar;
        islocal:boolean;
        private
        function GetValue:string;
        function GetType:string;
        public
        property Value:string read GetValue;
        property kind:string read GetType;
    end;
var vars:array[1..maxvar] of varrec;
const fname='vars.dat';

Procedure vResetAll;
procedure vSaveAll(filename:string=fname);
procedure vLoadAll(filename:string=fname);
function addvar(name:string;value:string=''):boolean;overload;
function SetVar(name:string;value:string=''):boolean;overload;
function SetVar(name:string;value:integer=0):boolean;overload;
function addvar(name:string;value:integer):boolean;overload;
function incvar(name:string;value:integer):boolean;overload;
function addvarl(name:string;value:integer):boolean;overload;
function addvarl(name:string;value:string):boolean;overload;
function findvar(name:string):integer;
function varcount:integer;
function GetVar(name:string):string;
function vartype(name:string):tuvar;

implementation

uses UMCaux;
function SetVar(name:string;value:integer=0):boolean;overload;
begin
    result:=addvarl(name,value);
end;
function SetVar(name:string;value:string=''):boolean;
begin
    result:=addvarl(name,value);
end;
function vartype(name:string):tuvar;
begin
    result:=uUnk;
    if findvar(name)>0 then
        result:=vars[findvar(name)].vtype;
end;
function GetVar(name:string):string;
var k:integer;
begin
    result:='';
    k:=findvar(name);
    if k<>-1 then result:=vars[k].Value;
end;
function findvar(name:string):integer;
var i:integer;
begin
    result:=-1;
    for i:=1 to maxvar do
        if vars[i].used and (vars[i].name=name) then begin
            result:=i;
            exit;
        end;
end;
function varcount:integer;
var i:integer;
    k:integer;
begin
    k:=0;
    for i:=1 to maxvar do
        if vars[i].used then inc(k);
    result:=k;
end;
function addvar(name:string;value:integer):boolean;
var k,i:integer;

begin
    result:=false;
    k:=findvar(name);
    if k<>-1 then begin
        vars[k].datai:=value;
        vars[k].vtype:=uint;
        result:=true;
        exit;
    end;

    for i:=1 to maxvar do
        if not vars[i].used then begin
            vars[i].used:=true;
            vars[i].name:=name;
            vars[i].datai:=value;
            vars[i].vtype:=uint;
            vars[i].islocal:=false;
            result:=true;
            exit;
        end;
end;
function incvar(name:string;value:integer):boolean;
var k:integer;

begin
    result:=false;
    k:=findvar(name);
    if k<>-1 then begin
        inc(vars[k].datai,value);
        vars[k].vtype:=uint;
        result:=true;
        exit;
    end;

end;

function addvarl(name:string;value:string):boolean;overload;
var k,i:integer;
begin
    result:=false;
    k:=findvar(name);
    if k<>-1 then begin
        vars[k].datas:=value;
        vars[k].vtype:=ustr;
        result:=true;
        exit;
    end;

    for i:=1 to maxvar do
        if not vars[i].used then begin
            vars[i].used:=true;
            vars[i].name:=name;
            vars[i].datas:=value;
            vars[i].vtype:=ustr;
            vars[i].islocal:=true;
            result:=true;
            exit;
        end;
end;

function addvarl(name:string;value:integer):boolean;
var k,i:integer;
begin
    result:=false;
    k:=findvar(name);
    if k<>-1 then begin
        vars[k].datai:=value;
        vars[k].vtype:=uint;
        result:=true;
        exit;
    end;

    for i:=1 to maxvar do
        if not vars[i].used then begin
            vars[i].used:=true;
            vars[i].name:=name;
            vars[i].datai:=value;
            vars[i].vtype:=uint;
            vars[i].islocal:=true;
            result:=true;
            exit;
        end;
end;


function addvar(name:string;value:string):boolean;
var k,i:integer;
begin
    result:=false;
    k:=findvar(name);
    if k<>-1 then begin
        vars[k].datas:=value;
        vars[k].vtype:=ustr;
        result:=true;
        exit;
    end;
    for i:=1 to maxvar do
        if not vars[i].used then begin
            vars[i].used:=true;
            vars[i].name:=name;
            vars[i].datas:=value;
            vars[i].vtype:=ustr;
            vars[i].islocal:=false;
            result:=true;
            exit;
        end;
end;
function varrec.GetType:string;
begin
    case vtype of
        ustr:result:='String';
        uint:result:='Integer';
    else
        result:='<unknown>';
    end;
end;
function varrec.GetValue:string;
begin
    result:='';
    case vtype of
        ustr:result:=datas;
        uint:result:=inttostr(datai);
    end;
end;

procedure vSaveAll(filename:string=fname);
var n:tinifile;
    i:integer;
begin
    if fileexists(filename) then deletefile(filename);
    n:=tinifile.Create(filename);
    for i:=1 to maxvar do
        if vars[i].used and not vars[i].islocal then
            with vars[i] do begin
                case vtype of
                    uStr:n.WriteString('String',name,datas);
                    uInt:n.WriteInteger('Integer',name,datai);
                else
                    continue;
                end;
            end;
    n.Free;
end;
procedure vLoadAll(filename:string=fname);
var n:tinifile;
    {i,}j:integer;
    li:tstringlist;

begin
    vResetAll;
    li:=tstringlist.create;
    if not fileexists(filename) then exit;
    n:=tinifile.Create(filename);
//    for i:=1 to maxvar do begin
        n.ReadSection('String',li);
        if li.Count<>0 then
            for j:=0 to li.Count-1 do
                addvar(li.Strings[j],n.ReadString('String',li.Strings[j],''));

        n.ReadSection('Integer',li);
        if li.Count<>0 then
            for j:=0 to li.Count-1 do
                addvar(li.Strings[j],n.ReadInteger('Integer',li.Strings[j],0));
//    end;
    n.Free;
    li.Free;
end;
Procedure vResetAll;
var i:integer;
begin
    for i:=1 to maxvar do
        with vars[i] do begin
            used:=false;
            name:='';
            datas:='';
            datai:=0;
            vtype:=ustr;
            islocal:=true;
        end;
    addvar('ver',GetUMCver);
    addvar('Author','Stanislav V. Mikov');

end;


end.
