unit UMCwordlist;

interface
type Tword=object
    Data:pchar;
    Len:integer;
    Next:Pointer;
    Freq:integer;
    procedure init;
    procedure AddWord(str:string);
    function Length:integer;
    function Value:string;
    constructor create(s:string='');
    destructor destroy;
    procedure ChangeTo(s:string);
    procedure savetofile(filename:string);
    procedure put(s:string);
end;

TYPE pWord=^Tword;

var words:Tword;

implementation

uses sysutils, classes;
{ Tword }

procedure Tword.AddWord(str: string);
var p:pword;
    m:tword;
begin
    p:=@self;
    m.create(str);
    m.freq:=1;
    while p^.Next<>nil do p:=p^.Next;
    p^.Next:=@m;
end;

procedure Tword.ChangeTo(s: string);
begin
    if data<>nil then freemem(data);
    GetMem(data,system.length(s));
    data:=pchar(s);
    len:=system.length(s);
end;

constructor Tword.create(s: string);
begin
    init;
    Changeto(s);
    len:=system.length(s);
end;

destructor Tword.destroy;
var p:pword;
begin
    if next<>nil then begin
        p:=self.next;
        p^.destroy;
    end;
//    if data<>nil then freemem(data);

end;

procedure Tword.init;
begin
    data:=nil;
    len:=0;
    freq:=0;
    next:=nil;
end;

function Tword.Length: integer;
var p:pword;
    i:integer;
begin

    i:=0;
    p:=@self;
    repeat
        p:=p^.Next;
        inc(i);
    until p^.Next=nil;
    result:=i;

end;

procedure Tword.put(s: string);
var p:pword;
begin
    p:=@self;
    repeat
        p:=p^.Next;
        if p^.Value=s then begin
            inc(p^.Freq);
            exit;
        end;
    until p=nil;
    addword(s);

end;

procedure Tword.savetofile(filename: string);
var n:tfilestream;
    l:integer;
var p:pword;
begin
    try
    if not fileexists(filename) then
    n:=tfilestream.Create(filename,fmCreate)
    else
    n:=tfilestream.Create(filename,fmOpenWrite);
    n.Write('UMCw',4);
    l:=length;
    n.Write(l,sizeof(l));

    p:=@self;
    repeat
        p:=p^.Next;

        n.write(p^.len,sizeof(p^.len));
        n.Write(p^.data,p^.Len);
    until p.Next=nil;
    n.Free;


    finally

    end;

end;

function Tword.Value: string;
begin
    result:='';
    if (@self=nil)or(data=nil) then exit;
    result:=strpas(data);

end;

end.
